/* Function Parser for C++ v4.0.5   

   Note: This file contains generated code and is thus not
   intended to be to be modified by hand. It was generated by
   fpoptimizer/bytecoderules_parser which is available in the
   development package.

   Note: You don't need to add this file to your project. It's
   enough for it to be in the same directory as fparser.cc. This
   file is internally #included by fparser.cc.
*/

#define FP_TRACE_OPCODENAME(op) \
    (op < VarBegin \
        ? FP_GetOpcodeName(OPCODE(op)) \
        : findName(data->namePtrs,op,NameData<Value_t>::VARIABLE))
#define FP_TRACE_BYTECODE_OPTIMIZATION(srcline,from,to,with) \
    /*std::cout << "Changing \"" from "\"\t(line " #srcline ")\n" \
                   "    into \"" to "\"\n" with*/

  unsigned* ByteCodePtr;
  Value_t*   ImmedPtr;

  #define FP_ReDefinePointers() \
    ByteCodePtr = !data->ByteCode.empty() ? &data->ByteCode[0] + data->ByteCode.size() - 1 : 0; \
    ImmedPtr    = !data->Immed.empty()    ? &data->Immed[0]    + data->Immed.size()    - 1 : 0;
  FP_ReDefinePointers();

#if(!FP_FLOAT_VERSION)
	Value_t x;
	unsigned A;
	Value_t y;
	unsigned B;
	unsigned C;
	unsigned D;
	switch(opcode)
	{
	TailCall_cAbs:
	case cAbs:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(197,"cNeg cAbs", "cAbs", "");
			/* opcode = cAbs; */ // redundant, matches cAbs @ 0
			goto Laa;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(40,
				"x cAbs",
				"[fp_abs(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lab;
		default:
			A = ByteCodePtr[0];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(258,
					"A[IsNeverNegativeValueOpcode(A)] cAbs",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	TailCall_cAdd:
	case cAdd:
		switch(ByteCodePtr[0])
		{
		case cDup:
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(147,"cDup cAdd cDup cAdd", "[Value_t(4)] cMul", "");
					goto Lac;
				}
				break;
			case cMul:
				if(ByteCodePtr[-2] == cAdd)
				{
					if(ByteCodePtr[-3] == cDup)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(148,"cDup cAdd cMul cDup cAdd", "cMul [Value_t(4)] cMul", "");
						goto Lad;
					}
				}
				break;
			}
			break;
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(150,
						"cDup x cMul cAdd",
						"[x+Value_t(1)] cMul",
						"    with x = " << x << "\n");
					goto Lae;
				}
			}
			break;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(204,"cNeg cAdd", "cSub", "");
			goto Laf;
		case cImmed:
			x = ImmedPtr[0];
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				if(ByteCodePtr[-2] == cImmed)
				{
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(141,
						"y cAdd x cAdd",
						"[y+x] cAdd",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					/* opcode = cAdd; */ // redundant, matches cAdd @ 0
					goto Lag;
				}
				break;
			case cImmed:
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(76,
					"y x cAdd",
					"[y+x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lah;
			}
			if(x==Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(75,
					"x[x==Value_t(0)] cAdd",
					"",
					"    with x = " << x << "\n");
				goto Lai;
			}
			break;
		}
		goto Default0;
	TailCall_cAnd:
	case cAnd:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(130,
					"y x cAnd",
					"[fp_and(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Laj;
			}
		}
		goto Default0;
	TailCall_cDiv:
	case cDiv:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(120,"cDup cDiv", "[Value_t(0)] cMul [Value_t(1)] cAdd", "");
			goto Lak;
		case cImmed:
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cNeg:
					FP_TRACE_BYTECODE_OPTIMIZATION(138,
						"cNeg x[x!=Value_t(0)] cDiv",
						"[-x] cDiv",
						"    with x = " << x << "\n");
					/* opcode = cDiv; */ // redundant, matches cDiv @ 0
					goto Lal;
				case cImmed:
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(73,
						"y x[x!=Value_t(0)] cDiv",
						"[y/x]",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
					goto Lam;
				}
			}
			if(x==Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(72,
					"x[x==Value_t(1)] cDiv",
					"",
					"    with x = " << x << "\n");
				goto Lai;
			}
			break;
		}
		goto Default0;
	TailCall_cEqual:
	case cEqual:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(1))
			{
				A = ByteCodePtr[-1];
				if(IsLogicalOpcode(A))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(286,
						"A[IsLogicalOpcode(A)] x[x==Value_t(1)] cEqual",
						"A",
						"    with x = " << x
						    << ", A = " << FP_TRACE_OPCODENAME(A)
						    << "\n");
					/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
					goto Lai;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(128,
					"y x cEqual",
					"[fp_equal(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lan;
			}
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(216,
						"cAbs x[x==Value_t(0)] cEqual",
						"[x] cEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cEqual; */ // redundant, matches cEqual @ 0
					goto Lao;
				case cSqr:
					FP_TRACE_BYTECODE_OPTIMIZATION(218,
						"cSqr x[x==Value_t(0)] cEqual",
						"[x] cEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cEqual; */ // redundant, matches cEqual @ 0
					goto Lao;
				}
				FP_TRACE_BYTECODE_OPTIMIZATION(276,
					"x[x==Value_t(0)] cEqual",
					"cNot",
					"    with x = " << x << "\n");
				goto Lap;
			}
		}
		goto Default0;
	TailCall_cGreater:
	case cGreater:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(278,
						"cAbs x[x==Value_t(0)] cGreater",
						"cNotNot",
						"    with x = " << x << "\n");
					goto Laq;
				default:
					A = ByteCodePtr[-1];
					if(IsNeverNegativeValueOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(282,
							"A[IsNeverNegativeValueOpcode(A)] x[x==Value_t(0)] cGreater",
							"A cNotNot",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
						goto Lba;
					}
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(126,
					"y x cGreater",
					"[fp_less(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbb;
			}
		}
		goto Default0;
	TailCall_cGreaterOrEq:
	case cGreaterOrEq:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(1))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(279,
						"cAbs x[x==Value_t(1)] cGreaterOrEq",
						"cNotNot",
						"    with x = " << x << "\n");
					goto Laq;
				default:
					A = ByteCodePtr[-1];
					if(IsNeverNegativeValueOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(283,
							"A[IsNeverNegativeValueOpcode(A)] x[x==Value_t(1)] cGreaterOrEq",
							"A cNotNot",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
						goto Lba;
					}
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(127,
					"y x cGreaterOrEq",
					"[fp_lessOrEq(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbc;
			}
		}
		goto Default0;
	TailCall_cInv:
	case cInv:
		switch(ByteCodePtr[0])
		{
		case cInv:
			FP_TRACE_BYTECODE_OPTIMIZATION(198,"cInv cInv", "", "");
			goto Lbd;
		case cSqrt:
			FP_TRACE_BYTECODE_OPTIMIZATION(67,"cSqrt cInv", "cRSqrt", "");
			goto Lbe;
		case cImmed:
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(69,
					"x[x!=Value_t(0)] cInv",
					"[Value_t(1)/x]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lbf;
			}
			break;
		}
		goto Default0;
	TailCall_cLess:
	case cLess:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(1))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(280,
						"cAbs x[x==Value_t(1)] cLess",
						"cNot",
						"    with x = " << x << "\n");
					goto Lbg;
				default:
					A = ByteCodePtr[-1];
					if(IsNeverNegativeValueOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(284,
							"A[IsNeverNegativeValueOpcode(A)] x[x==Value_t(1)] cLess",
							"A cNot",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
						goto Lap;
					}
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(124,
					"y x cLess",
					"[fp_less(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbh;
			}
		}
		goto Default0;
	TailCall_cLessOrEq:
	case cLessOrEq:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(281,
						"cAbs x[x==Value_t(0)] cLessOrEq",
						"cNot",
						"    with x = " << x << "\n");
					goto Lbg;
				default:
					A = ByteCodePtr[-1];
					if(IsNeverNegativeValueOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(285,
							"A[IsNeverNegativeValueOpcode(A)] x[x==Value_t(0)] cLessOrEq",
							"A cNot",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
						goto Lap;
					}
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(125,
					"y x cLessOrEq",
					"[fp_lessOrEq(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbi;
			}
		}
		goto Default0;
	TailCall_cMax:
	case cMax:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(110,"cDup cMax", "", "");
			goto Lbd;
		case cImmed:
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(82,
					"y x cMax",
					"[fp_max(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbj;
			}
			break;
		default:
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cDup:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(112,
							"B[B==A] cDup A[A>=VarBegin] cMax",
							"B cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cDup; */ // redundant, matches cDup @ 2
						goto Lbd;
					}
					break;
				case cMax:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(114,
							"B[B==A] cMax A[A>=VarBegin] cMax",
							"B cMax",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cMax; */ // redundant, matches cMax @ 2
						goto Lbd;
					}
					break;
				}
			}
		}
		goto Default0;
	TailCall_cMin:
	case cMin:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(109,"cDup cMin", "", "");
			goto Lbd;
		case cImmed:
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(81,
					"y x cMin",
					"[fp_min(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lbk;
			}
			break;
		default:
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cDup:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(111,
							"B[B==A] cDup A[A>=VarBegin] cMin",
							"B cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cDup; */ // redundant, matches cDup @ 2
						goto Lbd;
					}
					break;
				case cMin:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(113,
							"B[B==A] cMin A[A>=VarBegin] cMin",
							"B cMin",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cMin; */ // redundant, matches cMin @ 2
						goto Lbd;
					}
					break;
				}
			}
		}
		goto Default0;
	TailCall_cMod:
	case cMod:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				if(ByteCodePtr[-1] == cImmed)
				{
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(74,
						"y x[x!=Value_t(0)] cMod",
						"[fp_mod(y,x)]",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
					goto Lbl;
				}
			}
		}
		goto Default0;
	TailCall_cMul:
	case cMul:
		switch(ByteCodePtr[0])
		{
		case cAdd:
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[0];
				A = ByteCodePtr[-2];
				if(A>=VarBegin)
				{
					if(ByteCodePtr[-3] == cImmed)
					{
						x = ImmedPtr[-1];
						FP_TRACE_BYTECODE_OPTIMIZATION(245,
							"x A[A>=VarBegin] y cAdd cMul",
							"[x] A cMul [y*x] cAdd",
							"    with y = " << y
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						/* ByteCodePtr[-3] = cImmed; */ // redundant, matches x @ 4
						goto Lbm;
					}
				}
			}
			goto Default1;
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(359,"cDup cMul", "cSqr", "");
			goto Lbn;
		case cInv:
			FP_TRACE_BYTECODE_OPTIMIZATION(203,"cInv cMul", "cDiv", "");
			goto Lbo;
		case cNeg:
			A = ByteCodePtr[-1];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-2])
				{
				case cMul:
					B = ByteCodePtr[-3];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(351,
							"B[B==A] cMul A[A>=VarBegin] cNeg cMul",
							"B cSqr cMul cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-3] = B; */ // redundant, matches B @ 4
						goto Lbp;
					}
					goto Default2;
				default: Default2:;
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(345,
							"B[B==A] A[A>=VarBegin] cNeg cMul",
							"B cSqr cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lbq;
					}
				}
			}
			goto Default1;
		case cPow:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(151,
						"cDup x cPow cMul",
						"[x+Value_t(1)] cPow",
						"    with x = " << x << "\n");
					goto Lca;
				}
			}
			goto Default1;
		case cImmed:
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cMul:
					A = ByteCodePtr[-2];
					if(A>=VarBegin)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(94,
							"A[A>=VarBegin] cMul x[x==Value_t(0)] cMul",
							"[x] cMul",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lcb;
					}
					goto Default3;
				default: Default3:;
					A = ByteCodePtr[-1];
					if(IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A))
					{
						switch(ByteCodePtr[-2])
						{
						case cImmed:
							y = ImmedPtr[-1];
							FP_TRACE_BYTECODE_OPTIMIZATION(93,
								"y A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
								"[x] cMul",
								"    with x = " << x
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << ", y = " << y
								    << "\n");
							/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
							/* opcode = cMul; */ // redundant, matches cMul @ 0
							goto Lcc;
						default:
							B = ByteCodePtr[-2];
							if(IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B))
							{
								switch(ByteCodePtr[-3])
								{
								case cImmed:
									y = ImmedPtr[-1];
									FP_TRACE_BYTECODE_OPTIMIZATION(97,
										"y B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
										"A [x] cMul",
										"    with x = " << x
										    << ", A = " << FP_TRACE_OPCODENAME(A)
										    << ", B = " << FP_TRACE_OPCODENAME(B)
										    << ", y = " << y
										    << "\n");
									/* opcode = cMul; */ // redundant, matches cMul @ 0
									goto Lcd;
								default:
									C = ByteCodePtr[-3];
									if(C>=VarBegin)
									{
										FP_TRACE_BYTECODE_OPTIMIZATION(95,
											"C[C>=VarBegin] B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
											"A [x] cMul",
											"    with x = " << x
											    << ", A = " << FP_TRACE_OPCODENAME(A)
											    << ", B = " << FP_TRACE_OPCODENAME(B)
											    << ", C = " << FP_TRACE_OPCODENAME(C)
											    << "\n");
										/* opcode = cMul; */ // redundant, matches cMul @ 0
										goto Lce;
									}
									if(IsUnaryOpcode(C)&&!HasInvalidRangesOpcode(C))
									{
										FP_TRACE_BYTECODE_OPTIMIZATION(96,
											"C[IsUnaryOpcode(C)&&!HasInvalidRangesOpcode(C)] B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
											"B A [x] cMul",
											"    with x = " << x
											    << ", A = " << FP_TRACE_OPCODENAME(A)
											    << ", B = " << FP_TRACE_OPCODENAME(B)
											    << ", C = " << FP_TRACE_OPCODENAME(C)
											    << "\n");
										/* opcode = cMul; */ // redundant, matches cMul @ 0
										goto Lcf;
									}
								}
							}
							if(B>=VarBegin)
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(91,
									"B[B>=VarBegin] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
									"[x] cMul",
									"    with x = " << x
									    << ", A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << "\n");
								/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lcb;
							}
							if(IsUnaryOpcode(B)&&!HasInvalidRangesOpcode(B))
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(92,
									"B[IsUnaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
									"A [x] cMul",
									"    with x = " << x
									    << ", A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << "\n");
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lcg;
							}
						}
					}
					if(A>=VarBegin)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(89,
							"A[A>=VarBegin] x[x==Value_t(0)] cMul",
							"[x]",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						goto Lch;
					}
					if(IsUnaryOpcode(A)&&!HasInvalidRangesOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(90,
							"A[IsUnaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
							"[x] cMul",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lci;
					}
				}
			}
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				switch(ByteCodePtr[-2])
				{
				case cDup:
					FP_TRACE_BYTECODE_OPTIMIZATION(155,
						"cDup cAdd x cMul",
						"[x+x] cMul",
						"    with x = " << x << "\n");
					/* opcode = cMul; */ // redundant, matches cMul @ 0
					goto Lcj;
				case cMul:
					if(ByteCodePtr[-3] == cImmed)
					{
						y = ImmedPtr[-1];
						A = ByteCodePtr[-4];
						if(A>=VarBegin)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(243,
								"A[A>=VarBegin] y cMul cAdd x cMul",
								"[x] cMul A [y*x] cMul cAdd",
								"    with x = " << x
								    << ", y = " << y
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << "\n");
							goto Lck;
						}
					}
					break;
				case cImmed:
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(242,
						"y cAdd x cMul",
						"[x] cMul [y*x] cAdd",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					goto Lcl;
				}
				break;
			case cMul:
				switch(ByteCodePtr[-2])
				{
				case cAdd:
					if(ByteCodePtr[-3] == cDup)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(157,
							"cDup cAdd cMul x cMul",
							"cMul [x+x] cMul",
							"    with x = " << x << "\n");
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lcm;
					}
					break;
				case cImmed:
					y = ImmedPtr[-1];
					if(y*x==Value_t(1))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(145,
							"y[y*x==Value_t(1)] cMul x cMul",
							"",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						goto Lcn;
					}
					FP_TRACE_BYTECODE_OPTIMIZATION(146,
						"y cMul x cMul",
						"[y*x] cMul",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					/* opcode = cMul; */ // redundant, matches cMul @ 0
					goto Lco;
				}
				break;
			case cNeg:
				FP_TRACE_BYTECODE_OPTIMIZATION(135,
					"cNeg x cMul",
					"[-x] cMul",
					"    with x = " << x << "\n");
				/* opcode = cMul; */ // redundant, matches cMul @ 0
				goto Lcp;
			case cSub:
				if(ByteCodePtr[-2] == cMul)
				{
					if(ByteCodePtr[-3] == cImmed)
					{
						y = ImmedPtr[-1];
						A = ByteCodePtr[-4];
						if(A>=VarBegin)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(244,
								"A[A>=VarBegin] y cMul cSub x cMul",
								"[x] cMul A [y*x] cMul cSub",
								"    with x = " << x
								    << ", y = " << y
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << "\n");
							goto Lcq;
						}
					}
				}
				break;
			case cImmed:
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(71,
					"y x cMul",
					"[y*x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lda;
			}
			if(x==Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(70,
					"x[x==Value_t(1)] cMul",
					"",
					"    with x = " << x << "\n");
				goto Lai;
			}
			if(x==Value_t(2))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(100,
					"x[x==Value_t(2)] cMul",
					"cDup cAdd",
					"    with x = " << x << "\n");
				goto Ldb;
			}
			if(x==Value_t(-1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(137,
					"x[x==Value_t(-1)] cMul",
					"cNeg",
					"    with x = " << x << "\n");
				goto Ldc;
			}
			break;
		default: Default1:;
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cMul:
					switch(ByteCodePtr[-2])
					{
					case cNeg:
						B = ByteCodePtr[-3];
						if(B==A)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(348,
								"B[B==A] cNeg cMul A[A>=VarBegin] cMul",
								"B cSqr cMul cNeg",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", B = " << FP_TRACE_OPCODENAME(B)
								    << "\n");
							/* ByteCodePtr[-3] = B; */ // redundant, matches B @ 4
							goto Lbp;
						}
						goto Default4;
					default: Default4:;
						B = ByteCodePtr[-2];
						if(B==A)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(339,
								"B[B==A] cMul A[A>=VarBegin] cMul",
								"B cSqr cMul",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", B = " << FP_TRACE_OPCODENAME(B)
								    << "\n");
							/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
							/* opcode = cMul; */ // redundant, matches cMul @ 0
							goto Ldd;
						}
					}
					goto Default5;
				case cNeg:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(342,
							"B[B==A] cNeg A[A>=VarBegin] cMul",
							"B cSqr cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lbq;
					}
					goto Default5;
				default: Default5:;
					B = ByteCodePtr[-1];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(336,
							"B[B==A] A[A>=VarBegin] cMul",
							"B cSqr",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-1] = B; */ // redundant, matches B @ 2
						goto Lbn;
					}
				}
			}
			if(IsUnaryOpcode(A))
			{
				B = ByteCodePtr[-1];
				if(B>=VarBegin&&data->ByteCode.size()>1)
				{
					if(ByteCodePtr[-2] == cMul)
					{
						C = ByteCodePtr[-3];
						if(C==A)
						{
							D = ByteCodePtr[-4];
							if(D==B)
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(358,
									"D[D==B] C[C==A] cMul B[B>=VarBegin&&data->ByteCode.size()>1] A[IsUnaryOpcode(A)] cMul",
									"D C cSqr cMul",
									"    with A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << ", C = " << FP_TRACE_OPCODENAME(C)
									    << ", D = " << FP_TRACE_OPCODENAME(D)
									    << "\n");
								/* ByteCodePtr[-4] = D; */ // redundant, matches D @ 5
								/* ByteCodePtr[-3] = C; */ // redundant, matches C @ 4
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lde;
							}
						}
					}
				}
			}
		}
		goto Default0;
	TailCall_cNEqual:
	case cNEqual:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(1))
			{
				A = ByteCodePtr[-1];
				if(IsLogicalOpcode(A))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(287,
						"A[IsLogicalOpcode(A)] x[x==Value_t(1)] cNEqual",
						"A cNot",
						"    with x = " << x
						    << ", A = " << FP_TRACE_OPCODENAME(A)
						    << "\n");
					/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
					goto Lap;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(129,
					"y x cNEqual",
					"[fp_nequal(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Ldf;
			}
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(217,
						"cAbs x[x==Value_t(0)] cNEqual",
						"[x] cNEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cNEqual; */ // redundant, matches cNEqual @ 0
					goto Ldg;
				case cSqr:
					FP_TRACE_BYTECODE_OPTIMIZATION(219,
						"cSqr x[x==Value_t(0)] cNEqual",
						"[x] cNEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cNEqual; */ // redundant, matches cNEqual @ 0
					goto Ldg;
				}
				FP_TRACE_BYTECODE_OPTIMIZATION(277,
					"x[x==Value_t(0)] cNEqual",
					"cNotNot",
					"    with x = " << x << "\n");
				goto Lba;
			}
		}
		goto Default0;
	TailCall_cNeg:
	case cNeg:
		switch(ByteCodePtr[0])
		{
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(136,
					"x cMul cNeg",
					"[-x] cMul",
					"    with x = " << x << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches x @ 2
				goto Ldh;
			}
			break;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(199,"cNeg cNeg", "", "");
			goto Lbd;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(68,
				"x cNeg",
				"[-x]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ldi;
		}
		goto Default0;
	TailCall_cNot:
	case cNot:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(249,"cAbs cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Ldj;
		case cAbsNot:
			A = ByteCodePtr[-1];
			if(IsLogicalOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(254,
					"A[IsLogicalOpcode(A)] cAbsNot cNot",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lbd;
			}
			if(A!=cImmed)
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(255,
					"A[A!=cImmed] cAbsNot cNot",
					"A cAbsNotNot",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Ldk;
			}
			goto Default6;
		case cAbsNotNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(252,"cAbsNotNot cNot", "cAbsNot", "");
			goto Ldl;
		case cAdd:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(289,
					"x cAdd cNot",
					"[x] cEqual",
					"    with x = " << x << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches x @ 2
				goto Ldm;
			}
			goto Default6;
		case cEqual:
			FP_TRACE_BYTECODE_OPTIMIZATION(213,"cEqual cNot", "cNEqual", "");
			goto Ldn;
		case cGreater:
			FP_TRACE_BYTECODE_OPTIMIZATION(211,"cGreater cNot", "cLessOrEq", "");
			goto Ldo;
		case cGreaterOrEq:
			FP_TRACE_BYTECODE_OPTIMIZATION(212,"cGreaterOrEq cNot", "cLess", "");
			goto Ldp;
		case cLess:
			FP_TRACE_BYTECODE_OPTIMIZATION(209,"cLess cNot", "cGreaterOrEq", "");
			goto Ldq;
		case cLessOrEq:
			FP_TRACE_BYTECODE_OPTIMIZATION(210,"cLessOrEq cNot", "cGreater", "");
			goto Lea;
		case cNEqual:
			FP_TRACE_BYTECODE_OPTIMIZATION(214,"cNEqual cNot", "cEqual", "");
			goto Leb;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(248,"cNeg cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Ldj;
		case cNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(250,"cNot cNot", "cNotNot", "");
			goto Lec;
		case cNotNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(251,"cNotNot cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Ldj;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(85,
				"x cNot",
				"[fp_not(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Led;
		default: Default6:;
			A = ByteCodePtr[0];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(256,
					"A[IsNeverNegativeValueOpcode(A)] cNot",
					"A cAbsNot",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				goto Lee;
			}
		}
		goto Default0;
	TailCall_cNotNot:
	case cNotNot:
		if(ByteCodePtr[0] == cAdd)
		{
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(288,
					"x cAdd cNotNot",
					"[x] cNEqual",
					"    with x = " << x << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches x @ 2
				goto Lef;
			}
		}
		goto Default0;
	TailCall_cOr:
	case cOr:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(131,
					"y x cOr",
					"[fp_or(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Leg;
			}
		}
		goto Default0;
	TailCall_cSqr:
	case cSqr:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(354,"cAbs cSqr", "cSqr", "");
			/* opcode = cSqr; */ // redundant, matches cSqr @ 0
			goto Leh;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(353,"cNeg cSqr", "cSqr", "");
			/* opcode = cSqr; */ // redundant, matches cSqr @ 0
			goto Leh;
		}
		goto Default0;
	TailCall_cSub:
	case cSub:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(152,"cDup cSub", "[Value_t(0)] cMul", "");
			goto Lei;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(205,"cNeg cSub", "cAdd", "");
			goto Lej;
		case cImmed:
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(77,
					"x[x==Value_t(0)] cSub",
					"",
					"    with x = " << x << "\n");
				goto Lai;
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(78,
					"y x cSub",
					"[y-x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lek;
			}
			FP_TRACE_BYTECODE_OPTIMIZATION(168,
				"x cSub",
				"[-x] cAdd",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lel;
		}
		goto Default0;
	default: Default0:;
		A = opcode;
		if(IsComparisonOpcode(A))
		{
			if(ByteCodePtr[0] == cImmed)
			{
				x = ImmedPtr[0];
				switch(ByteCodePtr[-1])
				{
				case cAdd:
					if(ByteCodePtr[-2] == cImmed)
					{
						y = ImmedPtr[-1];
						FP_TRACE_BYTECODE_OPTIMIZATION(221,
							"y cAdd x A[IsComparisonOpcode(A)]",
							"[x-y] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << ", y = " << y
							    << "\n");
						/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
						goto Lem;
					}
					break;
				case cNeg:
					FP_TRACE_BYTECODE_OPTIMIZATION(222,
						"cNeg x A[IsComparisonOpcode(A)]",
						"[-x] {OppositeComparisonOpcode(A)}",
						"    with A = " << FP_TRACE_OPCODENAME(A)
						    << ", x = " << x
						    << "\n");
					goto Len;
				}
			}
		}
		if(A>=VarBegin&&data->ByteCode.size()>0)
		{
			B = ByteCodePtr[0];
			if(B==A)
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(356,
					"B[B==A] A[A>=VarBegin&&data->ByteCode.size()>0]",
					"B cDup",
					"    with A = " << FP_TRACE_OPCODENAME(A)
					    << ", B = " << FP_TRACE_OPCODENAME(B)
					    << "\n");
				/* ByteCodePtr[0] = B; */ // redundant, matches B @ 1
				goto Leo;
			}
		}
		if(IsUnaryOpcode(A))
		{
			B = ByteCodePtr[0];
			if(B>=VarBegin&&data->ByteCode.size()>1)
			{
				C = ByteCodePtr[-1];
				if(C==A)
				{
					D = ByteCodePtr[-2];
					if(D==B)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(357,
							"D[D==B] C[C==A] B[B>=VarBegin&&data->ByteCode.size()>1] A[IsUnaryOpcode(A)]",
							"D C cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << ", C = " << FP_TRACE_OPCODENAME(C)
							    << ", D = " << FP_TRACE_OPCODENAME(D)
							    << "\n");
						/* ByteCodePtr[-2] = D; */ // redundant, matches D @ 3
						/* ByteCodePtr[-1] = C; */ // redundant, matches C @ 2
						goto Lep;
					}
				}
			}
		}
	}
	goto Leq;
Laa: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     goto TailCall_cAbs;
Lab: ImmedPtr[0] = fp_abs(x); return;
Lac: data->Immed.push_back(Value_t(4));
     ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lfa: opcode = cMul;
Lfb: FP_ReDefinePointers();
Lfc: goto TailCall_cMul;
Lad: for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     data->Immed.push_back(Value_t(4));
     data->ByteCode.push_back(cImmed); goto Lfa;
Lae: ImmedPtr[0] = x+Value_t(1);
     ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lfd: opcode = cMul; goto Lfc;
Laf: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cSub;
Lfe: goto TailCall_cSub;
Lag: ImmedPtr[-1] = y+x;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lff: FP_ReDefinePointers();
Lfg: goto TailCall_cAdd;
Lah: ImmedPtr[-1] = y+x;
Lai: data->Immed.pop_back();
Lbd: data->ByteCode.pop_back(); return;
Laj: ImmedPtr[-1] = fp_and(x,y); goto Lai;
Lak: data->Immed.push_back(Value_t(0));
     ByteCodePtr[0] = cImmed;
     AddFunctionOpcode(cMul);
     data->Immed.push_back(Value_t(1));
Lfh: data->ByteCode.push_back(cImmed);
Lfi: opcode = cAdd; goto Lff;
Lal: ImmedPtr[0] = -x;
     ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lfj: goto TailCall_cDiv;
Lam: ImmedPtr[-1] = y/x; goto Lai;
Lan: ImmedPtr[-1] = fp_equal(y,x); goto Lai;
Lao: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lfk: goto TailCall_cEqual;
Lap: data->Immed.pop_back();
     data->ByteCode.pop_back();
Lfl: opcode = cNot;
     FP_ReDefinePointers();
Lfm: goto TailCall_cNot;
Laq: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lfn: opcode = cNotNot;
     FP_ReDefinePointers();
Lfo: goto TailCall_cNotNot;
Lba: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lfn;
Lbb: ImmedPtr[-1] = fp_less(x,y); goto Lai;
Lbc: ImmedPtr[-1] = fp_lessOrEq(x,y); goto Lai;
Lbe: data->ByteCode.pop_back();
     AddFunctionOpcode(cRSqrt); return;
Lbf: ImmedPtr[0] = Value_t(1)/x; return;
Lbg: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lfl;
Lbh: ImmedPtr[-1] = fp_less(y,x); goto Lai;
Lbi: ImmedPtr[-1] = fp_lessOrEq(y,x); goto Lai;
Lbj: ImmedPtr[-1] = fp_max(x,y); goto Lai;
Lbk: ImmedPtr[-1] = fp_min(x,y); goto Lai;
Lbl: ImmedPtr[-1] = fp_mod(y,x); goto Lai;
Lbm: ImmedPtr[-1] = x;
     data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(A);
Lfp: AddFunctionOpcode(cMul);
     data->Immed.push_back(y*x); goto Lfh;
Lbn: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cSqr;
Lfq: goto TailCall_cSqr;
Lbo: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cDiv; goto Lfj;
Lbp: for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr);
     AddFunctionOpcode(cMul);
Lga: opcode = cNeg;
     FP_ReDefinePointers();
     goto TailCall_cNeg;
Lbq: for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr); goto Lga;
Lca: ImmedPtr[0] = x+Value_t(1);
     ByteCodePtr[-2] = cImmed;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cPow); return;
Lcb: ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lfc;
Lcc: ImmedPtr[-1] = x;
Lgb: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lfb;
Lcd: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
Lgc: for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
Lgd: AddFunctionOpcode(A);
     data->Immed.push_back(x);
Lge: data->ByteCode.push_back(cImmed); goto Lfb;
Lce: data->Immed.pop_back(); goto Lgc;
Lcf: data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(B); goto Lgd;
Lcg: data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); goto Lgd;
Lch: ByteCodePtr[-1] = cImmed; goto Lbd;
Lci: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lfc;
Lcj: ImmedPtr[0] = x+x; goto Lcb;
Lck: ImmedPtr[-1] = x;
     ByteCodePtr[-4] = cImmed;
     data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     AddFunctionOpcode(A);
     data->Immed.push_back(y*x);
     data->ByteCode.push_back(cImmed);
     AddFunctionOpcode(cMul); goto Lfi;
Lcl: ImmedPtr[-1] = x;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lfp;
Lcm: data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     data->Immed.push_back(x+x); goto Lge;
Lcn: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); return;
Lco: ImmedPtr[-1] = y*x; goto Lgb;
Lcp: ImmedPtr[0] = -x; goto Lci;
Lcq: ImmedPtr[-1] = x;
     ByteCodePtr[-4] = cImmed;
     data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     AddFunctionOpcode(A);
     data->Immed.push_back(y*x);
     data->ByteCode.push_back(cImmed);
     AddFunctionOpcode(cMul);
     opcode = cSub;
     FP_ReDefinePointers(); goto Lfe;
Lda: ImmedPtr[-1] = y*x; goto Lai;
Ldb: ByteCodePtr[0] = cDup;
     ImmedPtr -= 1;
     data->Immed.pop_back();
Lgf: opcode = cAdd; goto Lfg;
Ldc: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lga;
Ldd: for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lgg: AddFunctionOpcode(cSqr); goto Lfb;
Lde: for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); goto Lgg;
Ldf: ImmedPtr[-1] = fp_nequal(y,x); goto Lai;
Ldg: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lgh: goto TailCall_cNEqual;
Ldh: ImmedPtr[0] = -x;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lfd;
Ldi: ImmedPtr[0] = -x; return;
Ldj: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lfm;
Ldk: data->ByteCode.pop_back();
     AddFunctionOpcode(cAbsNotNot); return;
Ldl: data->ByteCode.pop_back();
Lee: AddFunctionOpcode(cAbsNot); return;
Ldm: ImmedPtr[0] = x;
Leb: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cEqual; goto Lfk;
Ldn: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cNEqual; goto Lgh;
Ldo: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cLessOrEq;
     goto TailCall_cLessOrEq;
Ldp: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cLess;
     goto TailCall_cLess;
Ldq: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cGreaterOrEq;
     goto TailCall_cGreaterOrEq;
Lea: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cGreater;
     goto TailCall_cGreater;
Lec: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cNotNot; goto Lfo;
Led: ImmedPtr[0] = fp_not(x); return;
Lef: ImmedPtr[0] = x; goto Ldn;
Leg: ImmedPtr[-1] = fp_or(x,y); goto Lai;
Leh: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lfq;
Lei: data->Immed.push_back(Value_t(0));
     ByteCodePtr[0] = cImmed; goto Lfa;
Lej: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lgf;
Lek: ImmedPtr[-1] = y-x; goto Lai;
Lel: ImmedPtr[0] = -x; goto Lgf;
Lem: ImmedPtr[-1] = x-y;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(A); return;
Len: ImmedPtr[0] = -x;
     ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back();
     AddFunctionOpcode(OppositeComparisonOpcode(A)); return;
Leo: data->ByteCode.push_back(cDup); return;
Lep: ByteCodePtr[0] = cDup; return;
Leq: data->ByteCode.push_back(opcode); return;
return;
// This list of dummy gotos is here to inhibit
// compiler warnings on unused labels
goto TailCall_cAnd;goto TailCall_cInv;goto TailCall_cMax;
goto TailCall_cMin;goto TailCall_cMod;goto TailCall_cNeg;
goto TailCall_cNotNot;goto TailCall_cOr;goto TailCall_cSub;
#endif

#if(FP_FLOAT_VERSION)
	Value_t x;
	unsigned A;
	Value_t y;
	unsigned B;
	unsigned C;
	unsigned D;
	switch(opcode)
	{
	TailCall_cAbs:
	case cAbs:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(197,"cNeg cAbs", "cAbs", "");
			/* opcode = cAbs; */ // redundant, matches cAbs @ 0
			goto Laa;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(40,
				"x cAbs",
				"[fp_abs(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lab;
		default:
			A = ByteCodePtr[0];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(258,
					"A[IsNeverNegativeValueOpcode(A)] cAbs",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	TailCall_cAcos:
	case cAcos:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x>=Value_t(-1)&&x<=Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(44,
					"x[x>=Value_t(-1)&&x<=Value_t(1)] cAcos",
					"[fp_acos(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lac;
			}
		}
		goto Default0;
	TailCall_cAcosh:
	case cAcosh:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x>=Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(41,
					"x[x>=Value_t(1)] cAcosh",
					"[fp_acosh(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lad;
			}
		}
		goto Default0;
	TailCall_cAdd:
	case cAdd:
		switch(ByteCodePtr[0])
		{
		case cDup:
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(147,"cDup cAdd cDup cAdd", "[Value_t(4)] cMul", "");
					goto Lae;
				}
				break;
			case cMul:
				if(ByteCodePtr[-2] == cAdd)
				{
					if(ByteCodePtr[-3] == cDup)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(148,"cDup cAdd cMul cDup cAdd", "cMul [Value_t(4)] cMul", "");
						goto Laf;
					}
				}
				break;
			}
			break;
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(150,
						"cDup x cMul cAdd",
						"[x+Value_t(1)] cMul",
						"    with x = " << x << "\n");
					goto Lag;
				}
			}
			break;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(204,"cNeg cAdd", "cSub", "");
			goto Lah;
		case cImmed:
			x = ImmedPtr[0];
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				if(ByteCodePtr[-2] == cImmed)
				{
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(141,
						"y cAdd x cAdd",
						"[y+x] cAdd",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					/* opcode = cAdd; */ // redundant, matches cAdd @ 0
					goto Lai;
				}
				break;
			case cImmed:
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(76,
					"y x cAdd",
					"[y+x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Laj;
			}
			if(x==Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(75,
					"x[x==Value_t(0)] cAdd",
					"",
					"    with x = " << x << "\n");
				goto Lak;
			}
			break;
		}
		goto Default0;
	TailCall_cAnd:
	case cAnd:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(130,
					"y x cAnd",
					"[fp_and(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lal;
			}
		}
		goto Default0;
	TailCall_cAsin:
	case cAsin:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x>=Value_t(-1)&&x<=Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(45,
					"x[x>=Value_t(-1)&&x<=Value_t(1)] cAsin",
					"[fp_asin(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lam;
			}
		}
		goto Default0;
	TailCall_cAsinh:
	case cAsinh:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(42,
				"x cAsinh",
				"[fp_asinh(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lan;
		}
		goto Default0;
	TailCall_cAtan:
	case cAtan:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(46,
				"x cAtan",
				"[fp_atan(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lao;
		}
		goto Default0;
	TailCall_cAtan2:
	case cAtan2:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(83,
					"y x cAtan2",
					"[fp_atan2(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lap;
			}
		}
		goto Default0;
	TailCall_cAtanh:
	case cAtanh:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x>Value_t(-1)&&x<Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(43,
					"x[x>Value_t(-1)&&x<Value_t(1)] cAtanh",
					"[fp_atanh(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Laq;
			}
		}
		goto Default0;
	TailCall_cCbrt:
	case cCbrt:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(47,
				"x cCbrt",
				"[fp_cbrt(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lba;
		}
		goto Default0;
	TailCall_cCeil:
	case cCeil:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(267,"cNeg cCeil", "cFloor cNeg", "");
			goto Lbb;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(48,
				"x cCeil",
				"[fp_ceil(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lbc;
		default:
			A = ByteCodePtr[0];
			if(IsAlwaysIntegerOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(261,
					"A[IsAlwaysIntegerOpcode(A)] cCeil",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	TailCall_cCos:
	case cCos:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(302,"cAbs cCos", "cCos", "");
			/* opcode = cCos; */ // redundant, matches cCos @ 0
			goto Lbd;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(304,"cNeg cCos", "cCos", "");
			/* opcode = cCos; */ // redundant, matches cCos @ 0
			goto Lbd;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(49,
				"x cCos",
				"[fp_cos(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lbe;
		}
		goto Default0;
	TailCall_cCosh:
	case cCosh:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(303,"cAbs cCosh", "cCosh", "");
			/* opcode = cCosh; */ // redundant, matches cCosh @ 0
			goto Lbf;
		case cAcosh:
			FP_TRACE_BYTECODE_OPTIMIZATION(193,"cAcosh cCosh", "", "");
			goto Lbg;
		case cAsinh:
			FP_TRACE_BYTECODE_OPTIMIZATION(316,"cAsinh cCosh", "[DO_STACKPLUS1] cSqr [Value_t(1)] cAdd cSqrt", "");
			incStackPtr();
			--StackPtr;
			goto Lbh;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(305,"cNeg cCosh", "cCosh", "");
			/* opcode = cCosh; */ // redundant, matches cCosh @ 0
			goto Lbf;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(50,
				"x cCosh",
				"[fp_cosh(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lbi;
		}
		goto Default0;
	TailCall_cDeg:
	case cDeg:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(65,
				"x cDeg",
				"[RadiansToDegrees(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lbj;
		}
		goto Default0;
	TailCall_cDiv:
	case cDiv:
		switch(ByteCodePtr[0])
		{
		case cCos:
			FP_TRACE_BYTECODE_OPTIMIZATION(319,"cCos cDiv", "cSec cMul", "");
			goto Lbk;
		case cCot:
			FP_TRACE_BYTECODE_OPTIMIZATION(323,"cCot cDiv", "cTan cMul", "");
			goto Lbl;
		case cCsc:
			FP_TRACE_BYTECODE_OPTIMIZATION(321,"cCsc cDiv", "cSin cMul", "");
			goto Lbm;
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(120,"cDup cDiv", "[Value_t(0)] cMul [Value_t(1)] cAdd", "");
			goto Lbn;
		case cExp:
			FP_TRACE_BYTECODE_OPTIMIZATION(273,"cExp cDiv", "cNeg cExp cMul", "");
			goto Lbo;
		case cExp2:
			FP_TRACE_BYTECODE_OPTIMIZATION(274,"cExp2 cDiv", "cNeg cExp2 cMul", "");
			goto Lbp;
		case cInv:
			FP_TRACE_BYTECODE_OPTIMIZATION(202,"cInv cDiv", "cMul", "");
			goto Lbq;
		case cPow:
			FP_TRACE_BYTECODE_OPTIMIZATION(272,"cPow cDiv", "cNeg cPow cMul", "");
			goto Lca;
		case cSec:
			FP_TRACE_BYTECODE_OPTIMIZATION(322,"cSec cDiv", "cCos cMul", "");
			goto Lcb;
		case cSin:
			FP_TRACE_BYTECODE_OPTIMIZATION(318,"cSin cDiv", "cCsc cMul", "");
			goto Lcc;
		case cTan:
			FP_TRACE_BYTECODE_OPTIMIZATION(320,"cTan cDiv", "cCot cMul", "");
			goto Lcd;
		case cImmed:
			x = ImmedPtr[0];
			if(x==Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(72,
					"x[x==Value_t(1)] cDiv",
					"",
					"    with x = " << x << "\n");
				goto Lak;
			}
			if(x!=Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cMul:
					if(ByteCodePtr[-2] == cImmed)
					{
						y = ImmedPtr[-1];
						if((y/x)==GetRadiansToDegreesFactor<Value_t>())
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(159,
								"y[(y/x)==GetRadiansToDegreesFactor<Value_t>()] cMul x[x!=Value_t(0)] cDiv",
								"cDeg",
								"    with x = " << x
								    << ", y = " << y
								    << "\n");
							goto Lce;
						}
						if((y/x)==GetDegreesToRadiansFactor<Value_t>())
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(160,
								"y[(y/x)==GetDegreesToRadiansFactor<Value_t>()] cMul x[x!=Value_t(0)] cDiv",
								"cRad",
								"    with x = " << x
								    << ", y = " << y
								    << "\n");
							goto Lcf;
						}
						FP_TRACE_BYTECODE_OPTIMIZATION(161,
							"y cMul x[x!=Value_t(0)] cDiv",
							"[y/x] cMul",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
						goto Lcg;
					}
					break;
				case cNeg:
					FP_TRACE_BYTECODE_OPTIMIZATION(138,
						"cNeg x[x!=Value_t(0)] cDiv",
						"[-x] cDiv",
						"    with x = " << x << "\n");
					/* opcode = cDiv; */ // redundant, matches cDiv @ 0
					goto Lch;
				case cImmed:
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(73,
						"y x[x!=Value_t(0)] cDiv",
						"[y/x]",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
					goto Lci;
				}
				FP_TRACE_BYTECODE_OPTIMIZATION(163,
					"x[x!=Value_t(0)] cDiv",
					"[Value_t(1)/x] cMul",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lcj;
			}
			break;
		}
		goto Default0;
	TailCall_cEqual:
	case cEqual:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(216,
						"cAbs x[x==Value_t(0)] cEqual",
						"[x] cEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cEqual; */ // redundant, matches cEqual @ 0
					goto Lck;
				case cSqr:
					FP_TRACE_BYTECODE_OPTIMIZATION(218,
						"cSqr x[x==Value_t(0)] cEqual",
						"[x] cEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cEqual; */ // redundant, matches cEqual @ 0
					goto Lck;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(128,
					"y x cEqual",
					"[fp_equal(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lcl;
			}
		}
		goto Default0;
	TailCall_cExp:
	case cExp:
		switch(ByteCodePtr[0])
		{
		case cAdd:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(269,
					"x cAdd cExp",
					"cExp [fp_exp(x)] cMul",
					"    with x = " << x << "\n");
				goto Lcm;
			}
			break;
		case cLog:
			A = ByteCodePtr[-1];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(183,
					"A[IsNeverNegativeValueOpcode(A)] cLog cExp",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lbg;
			}
			break;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(51,
				"x cExp",
				"[fp_exp(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lcn;
		}
		goto Default0;
	TailCall_cExp2:
	case cExp2:
		switch(ByteCodePtr[0])
		{
		case cAdd:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(270,
					"x cAdd cExp2",
					"cExp2 [fp_exp2(x)] cMul",
					"    with x = " << x << "\n");
				goto Lco;
			}
			break;
		case cLog2:
			A = ByteCodePtr[-1];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(184,
					"A[IsNeverNegativeValueOpcode(A)] cLog2 cExp2",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lbg;
			}
			break;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(52,
				"x cExp2",
				"[fp_exp2(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lcp;
		}
		FP_TRACE_BYTECODE_OPTIMIZATION(362,"cExp2", "[DO_STACKPLUS1] [fp_log(Value_t(2))] cMul cExp", "");
		incStackPtr();
		--StackPtr;
		goto Lcq;
	TailCall_cFloor:
	case cFloor:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(266,"cNeg cFloor", "cCeil cNeg", "");
			goto Lda;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(53,
				"x cFloor",
				"[fp_floor(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ldb;
		default:
			A = ByteCodePtr[0];
			if(IsAlwaysIntegerOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(260,
					"A[IsAlwaysIntegerOpcode(A)] cFloor",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	TailCall_cGreater:
	case cGreater:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(126,
					"y x cGreater",
					"[fp_less(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Ldc;
			}
			if(x==Value_t(-0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(296,
					"x[x==Value_t(-0.5)] cGreater",
					"cNeg cAbsNot",
					"    with x = " << x << "\n");
				goto Ldd;
			}
		}
		goto Default0;
	TailCall_cGreaterOrEq:
	case cGreaterOrEq:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				if(ByteCodePtr[-1] == cAbs)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(292,
						"cAbs x[x!=Value_t(0)] cGreaterOrEq",
						"[Value_t(0.5)/x] cMul cNotNot",
						"    with x = " << x << "\n");
					goto Lde;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(127,
					"y x cGreaterOrEq",
					"[fp_lessOrEq(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Ldf;
			}
			if(x==Value_t(0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(295,
					"x[x==Value_t(0.5)] cGreaterOrEq",
					"cAbsNotNot",
					"    with x = " << x << "\n");
				goto Ldg;
			}
		}
		goto Default0;
	TailCall_cInt:
	case cInt:
		switch(ByteCodePtr[0])
		{
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(54,
				"x cInt",
				"[fp_int(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ldh;
		default:
			A = ByteCodePtr[0];
			if(IsAlwaysIntegerOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(262,
					"A[IsAlwaysIntegerOpcode(A)] cInt",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	TailCall_cInv:
	case cInv:
		switch(ByteCodePtr[0])
		{
		case cCos:
			FP_TRACE_BYTECODE_OPTIMIZATION(325,"cCos cInv", "cSec", "");
			goto Ldi;
		case cCot:
			FP_TRACE_BYTECODE_OPTIMIZATION(329,"cCot cInv", "cTan", "");
			goto Ldj;
		case cCsc:
			FP_TRACE_BYTECODE_OPTIMIZATION(327,"cCsc cInv", "cSin", "");
			goto Ldk;
		case cInv:
			FP_TRACE_BYTECODE_OPTIMIZATION(198,"cInv cInv", "", "");
			goto Lbg;
		case cPow:
			FP_TRACE_BYTECODE_OPTIMIZATION(200,"cPow cInv", "cNeg cPow", "");
			goto Ldl;
		case cSec:
			FP_TRACE_BYTECODE_OPTIMIZATION(328,"cSec cInv", "cCos", "");
			goto Ldm;
		case cSin:
			FP_TRACE_BYTECODE_OPTIMIZATION(324,"cSin cInv", "cCsc", "");
			goto Ldn;
		case cSqrt:
			FP_TRACE_BYTECODE_OPTIMIZATION(67,"cSqrt cInv", "cRSqrt", "");
			goto Ldo;
		case cTan:
			FP_TRACE_BYTECODE_OPTIMIZATION(326,"cTan cInv", "cCot", "");
			goto Ldp;
		case cImmed:
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(69,
					"x[x!=Value_t(0)] cInv",
					"[Value_t(1)/x]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Ldq;
			}
			break;
		}
		goto Default0;
	TailCall_cLess:
	case cLess:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				if(ByteCodePtr[-1] == cAbs)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(291,
						"cAbs x[x!=Value_t(0)] cLess",
						"[Value_t(0.5)/x] cMul cNot",
						"    with x = " << x << "\n");
					goto Lea;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(124,
					"y x cLess",
					"[fp_less(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Leb;
			}
			if(x==Value_t(0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(294,
					"x[x==Value_t(0.5)] cLess",
					"cAbsNot",
					"    with x = " << x << "\n");
				goto Lec;
			}
		}
		goto Default0;
	TailCall_cLessOrEq:
	case cLessOrEq:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(125,
					"y x cLessOrEq",
					"[fp_lessOrEq(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Led;
			}
			if(x==Value_t(-0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(297,
					"x[x==Value_t(-0.5)] cLessOrEq",
					"cNeg cAbsNotNot",
					"    with x = " << x << "\n");
				goto Lee;
			}
		}
		goto Default0;
	TailCall_cLog:
	case cLog:
		switch(ByteCodePtr[0])
		{
		case cExp:
			FP_TRACE_BYTECODE_OPTIMIZATION(186,"cExp cLog", "", "");
			goto Lbg;
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(x>Value_t(0))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(374,
						"x[x>Value_t(0)] cMul cLog",
						"cLog [fp_log(x)] cAdd",
						"    with x = " << x << "\n");
					goto Lef;
				}
			}
			break;
		case cSqr:
			FP_TRACE_BYTECODE_OPTIMIZATION(103,"cSqr cLog", "cAbs cLog cDup cAdd", "");
			goto Leg;
		case cImmed:
			x = ImmedPtr[0];
			if(x>Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(55,
					"x[x>Value_t(0)] cLog",
					"[fp_log(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Leh;
			}
			break;
		}
		goto Default0;
	TailCall_cLog10:
	case cLog10:
		switch(ByteCodePtr[0])
		{
		case cExp:
			FP_TRACE_BYTECODE_OPTIMIZATION(364,"cExp cLog10", "[DO_STACKPLUS1] [fp_log10(fp_const_e<Value_t>())] cMul", "");
			incStackPtr();
			--StackPtr;
			goto Lei;
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(x>Value_t(0))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(375,
						"x[x>Value_t(0)] cMul cLog10",
						"cLog10 [fp_log10(x)] cAdd",
						"    with x = " << x << "\n");
					goto Lej;
				}
			}
			break;
		case cSqr:
			FP_TRACE_BYTECODE_OPTIMIZATION(105,"cSqr cLog10", "cAbs cLog10 cDup cAdd", "");
			goto Lek;
		case cImmed:
			x = ImmedPtr[0];
			if(x>Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(56,
					"x[x>Value_t(0)] cLog10",
					"[fp_log10(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lel;
			}
			break;
		}
		goto Default0;
	TailCall_cLog2:
	case cLog2:
		switch(ByteCodePtr[0])
		{
		case cExp:
			FP_TRACE_BYTECODE_OPTIMIZATION(363,"cExp cLog2", "[DO_STACKPLUS1] [fp_log2(fp_const_e<Value_t>())] cMul", "");
			incStackPtr();
			--StackPtr;
			goto Lem;
		case cExp2:
			FP_TRACE_BYTECODE_OPTIMIZATION(187,"cExp2 cLog2", "", "");
			goto Lbg;
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(x>Value_t(0))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(373,
						"x[x>Value_t(0)] cMul cLog2",
						"cLog2 [fp_log2(x)] cAdd",
						"    with x = " << x << "\n");
					goto Len;
				}
			}
			break;
		case cSqr:
			FP_TRACE_BYTECODE_OPTIMIZATION(104,"cSqr cLog2", "cAbs cLog2 cDup cAdd", "");
			goto Leo;
		case cImmed:
			x = ImmedPtr[0];
			if(x>Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(57,
					"x[x>Value_t(0)] cLog2",
					"[fp_log2(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lep;
			}
			break;
		}
		goto Default0;
	TailCall_cMax:
	case cMax:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(110,"cDup cMax", "", "");
			goto Lbg;
		case cImmed:
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(82,
					"y x cMax",
					"[fp_max(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Leq;
			}
			break;
		default:
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cDup:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(112,
							"B[B==A] cDup A[A>=VarBegin] cMax",
							"B cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cDup; */ // redundant, matches cDup @ 2
						goto Lbg;
					}
					break;
				case cMax:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(114,
							"B[B==A] cMax A[A>=VarBegin] cMax",
							"B cMax",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cMax; */ // redundant, matches cMax @ 2
						goto Lbg;
					}
					break;
				}
			}
		}
		goto Default0;
	TailCall_cMin:
	case cMin:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(109,"cDup cMin", "", "");
			goto Lbg;
		case cImmed:
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(81,
					"y x cMin",
					"[fp_min(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lfa;
			}
			break;
		default:
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cDup:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(111,
							"B[B==A] cDup A[A>=VarBegin] cMin",
							"B cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cDup; */ // redundant, matches cDup @ 2
						goto Lbg;
					}
					break;
				case cMin:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(113,
							"B[B==A] cMin A[A>=VarBegin] cMin",
							"B cMin",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						/* ByteCodePtr[-1] = cMin; */ // redundant, matches cMin @ 2
						goto Lbg;
					}
					break;
				}
			}
		}
		goto Default0;
	TailCall_cMod:
	case cMod:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x!=Value_t(0))
			{
				if(ByteCodePtr[-1] == cImmed)
				{
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(74,
						"y x[x!=Value_t(0)] cMod",
						"[fp_mod(y,x)]",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
					goto Lfb;
				}
			}
		}
		goto Default0;
	TailCall_cMul:
	case cMul:
		switch(ByteCodePtr[0])
		{
		case cAdd:
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[0];
				A = ByteCodePtr[-2];
				if(A>=VarBegin)
				{
					if(ByteCodePtr[-3] == cImmed)
					{
						x = ImmedPtr[-1];
						FP_TRACE_BYTECODE_OPTIMIZATION(245,
							"x A[A>=VarBegin] y cAdd cMul",
							"[x] A cMul [y*x] cAdd",
							"    with y = " << y
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						/* ByteCodePtr[-3] = cImmed; */ // redundant, matches x @ 4
						goto Lfc;
					}
				}
			}
			goto Default1;
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(359,"cDup cMul", "cSqr", "");
			goto Lfd;
		case cInv:
			FP_TRACE_BYTECODE_OPTIMIZATION(203,"cInv cMul", "cDiv", "");
			goto Lfe;
		case cNeg:
			A = ByteCodePtr[-1];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-2])
				{
				case cMul:
					B = ByteCodePtr[-3];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(351,
							"B[B==A] cMul A[A>=VarBegin] cNeg cMul",
							"B cSqr cMul cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-3] = B; */ // redundant, matches B @ 4
						goto Lff;
					}
					goto Default2;
				default: Default2:;
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(345,
							"B[B==A] A[A>=VarBegin] cNeg cMul",
							"B cSqr cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lfg;
					}
				}
			}
			goto Default1;
		case cPow:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				if(ByteCodePtr[-2] == cDup)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(151,
						"cDup x cPow cMul",
						"[x+Value_t(1)] cPow",
						"    with x = " << x << "\n");
					goto Lfh;
				}
			}
			goto Default1;
		case cImmed:
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cMul:
					A = ByteCodePtr[-2];
					if(A>=VarBegin)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(94,
							"A[A>=VarBegin] cMul x[x==Value_t(0)] cMul",
							"[x] cMul",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lfi;
					}
					goto Default3;
				default: Default3:;
					A = ByteCodePtr[-1];
					if(IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A))
					{
						switch(ByteCodePtr[-2])
						{
						case cImmed:
							y = ImmedPtr[-1];
							FP_TRACE_BYTECODE_OPTIMIZATION(93,
								"y A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
								"[x] cMul",
								"    with x = " << x
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << ", y = " << y
								    << "\n");
							/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
							/* opcode = cMul; */ // redundant, matches cMul @ 0
							goto Lfj;
						default:
							B = ByteCodePtr[-2];
							if(IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B))
							{
								switch(ByteCodePtr[-3])
								{
								case cImmed:
									y = ImmedPtr[-1];
									FP_TRACE_BYTECODE_OPTIMIZATION(97,
										"y B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
										"A [x] cMul",
										"    with x = " << x
										    << ", A = " << FP_TRACE_OPCODENAME(A)
										    << ", B = " << FP_TRACE_OPCODENAME(B)
										    << ", y = " << y
										    << "\n");
									/* opcode = cMul; */ // redundant, matches cMul @ 0
									goto Lfk;
								default:
									C = ByteCodePtr[-3];
									if(C>=VarBegin)
									{
										FP_TRACE_BYTECODE_OPTIMIZATION(95,
											"C[C>=VarBegin] B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
											"A [x] cMul",
											"    with x = " << x
											    << ", A = " << FP_TRACE_OPCODENAME(A)
											    << ", B = " << FP_TRACE_OPCODENAME(B)
											    << ", C = " << FP_TRACE_OPCODENAME(C)
											    << "\n");
										/* opcode = cMul; */ // redundant, matches cMul @ 0
										goto Lfl;
									}
									if(IsUnaryOpcode(C)&&!HasInvalidRangesOpcode(C))
									{
										FP_TRACE_BYTECODE_OPTIMIZATION(96,
											"C[IsUnaryOpcode(C)&&!HasInvalidRangesOpcode(C)] B[IsBinaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
											"B A [x] cMul",
											"    with x = " << x
											    << ", A = " << FP_TRACE_OPCODENAME(A)
											    << ", B = " << FP_TRACE_OPCODENAME(B)
											    << ", C = " << FP_TRACE_OPCODENAME(C)
											    << "\n");
										/* opcode = cMul; */ // redundant, matches cMul @ 0
										goto Lfm;
									}
								}
							}
							if(B>=VarBegin)
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(91,
									"B[B>=VarBegin] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
									"[x] cMul",
									"    with x = " << x
									    << ", A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << "\n");
								/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lfi;
							}
							if(IsUnaryOpcode(B)&&!HasInvalidRangesOpcode(B))
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(92,
									"B[IsUnaryOpcode(B)&&!HasInvalidRangesOpcode(B)] A[IsBinaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
									"A [x] cMul",
									"    with x = " << x
									    << ", A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << "\n");
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lfn;
							}
						}
					}
					if(A>=VarBegin)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(89,
							"A[A>=VarBegin] x[x==Value_t(0)] cMul",
							"[x]",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						goto Lfo;
					}
					if(IsUnaryOpcode(A)&&!HasInvalidRangesOpcode(A))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(90,
							"A[IsUnaryOpcode(A)&&!HasInvalidRangesOpcode(A)] x[x==Value_t(0)] cMul",
							"[x] cMul",
							"    with x = " << x
							    << ", A = " << FP_TRACE_OPCODENAME(A)
							    << "\n");
						/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lfp;
					}
				}
			}
			switch(ByteCodePtr[-1])
			{
			case cAdd:
				switch(ByteCodePtr[-2])
				{
				case cDup:
					if(x+x==Value_t(1))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(154,
							"cDup[x+x==Value_t(1)] cAdd x cMul",
							"",
							"    with x = " << x << "\n");
						goto Lfq;
					}
					FP_TRACE_BYTECODE_OPTIMIZATION(155,
						"cDup cAdd x cMul",
						"[x+x] cMul",
						"    with x = " << x << "\n");
					/* opcode = cMul; */ // redundant, matches cMul @ 0
					goto Lga;
				case cMul:
					if(ByteCodePtr[-3] == cImmed)
					{
						y = ImmedPtr[-1];
						A = ByteCodePtr[-4];
						if(A>=VarBegin)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(243,
								"A[A>=VarBegin] y cMul cAdd x cMul",
								"[x] cMul A [y*x] cMul cAdd",
								"    with x = " << x
								    << ", y = " << y
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << "\n");
							goto Lgb;
						}
					}
					break;
				case cImmed:
					y = ImmedPtr[-1];
					FP_TRACE_BYTECODE_OPTIMIZATION(242,
						"y cAdd x cMul",
						"[x] cMul [y*x] cAdd",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					goto Lgc;
				}
				break;
			case cDeg:
				FP_TRACE_BYTECODE_OPTIMIZATION(106,
					"cDeg x cMul",
					"[RadiansToDegrees(x)] cMul",
					"    with x = " << x << "\n");
				/* opcode = cMul; */ // redundant, matches cMul @ 0
				goto Lgd;
			case cMul:
				switch(ByteCodePtr[-2])
				{
				case cAdd:
					if(ByteCodePtr[-3] == cDup)
					{
						if(x+x==Value_t(1))
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(156,
								"cDup[x+x==Value_t(1)] cAdd cMul x cMul",
								"cMul",
								"    with x = " << x << "\n");
							/* opcode = cMul; */ // redundant, matches cMul @ 0
							goto Lge;
						}
						FP_TRACE_BYTECODE_OPTIMIZATION(157,
							"cDup cAdd cMul x cMul",
							"cMul [x+x] cMul",
							"    with x = " << x << "\n");
						/* opcode = cMul; */ // redundant, matches cMul @ 0
						goto Lgf;
					}
					break;
				case cImmed:
					y = ImmedPtr[-1];
					if((y*x)==GetRadiansToDegreesFactor<Value_t>())
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(143,
							"y[(y*x)==GetRadiansToDegreesFactor<Value_t>()] cMul x cMul",
							"cDeg",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						goto Lce;
					}
					if((y*x)==GetDegreesToRadiansFactor<Value_t>())
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(144,
							"y[(y*x)==GetDegreesToRadiansFactor<Value_t>()] cMul x cMul",
							"cRad",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						goto Lcf;
					}
					if(y*x==Value_t(1))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(145,
							"y[y*x==Value_t(1)] cMul x cMul",
							"",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						goto Lgg;
					}
					FP_TRACE_BYTECODE_OPTIMIZATION(146,
						"y cMul x cMul",
						"[y*x] cMul",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					/* opcode = cMul; */ // redundant, matches cMul @ 0
					goto Lgh;
				}
				break;
			case cNeg:
				FP_TRACE_BYTECODE_OPTIMIZATION(135,
					"cNeg x cMul",
					"[-x] cMul",
					"    with x = " << x << "\n");
				/* opcode = cMul; */ // redundant, matches cMul @ 0
				goto Lgi;
			case cRad:
				FP_TRACE_BYTECODE_OPTIMIZATION(107,
					"cRad x cMul",
					"[DegreesToRadians(x)] cMul",
					"    with x = " << x << "\n");
				/* opcode = cMul; */ // redundant, matches cMul @ 0
				goto Lgj;
			case cSub:
				if(ByteCodePtr[-2] == cMul)
				{
					if(ByteCodePtr[-3] == cImmed)
					{
						y = ImmedPtr[-1];
						A = ByteCodePtr[-4];
						if(A>=VarBegin)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(244,
								"A[A>=VarBegin] y cMul cSub x cMul",
								"[x] cMul A [y*x] cMul cSub",
								"    with x = " << x
								    << ", y = " << y
								    << ", A = " << FP_TRACE_OPCODENAME(A)
								    << "\n");
							goto Lgk;
						}
					}
				}
				break;
			case cImmed:
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(71,
					"y x cMul",
					"[y*x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lgl;
			}
			if(x==Value_t(1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(70,
					"x[x==Value_t(1)] cMul",
					"",
					"    with x = " << x << "\n");
				goto Lak;
			}
			if(x==Value_t(2))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(100,
					"x[x==Value_t(2)] cMul",
					"cDup cAdd",
					"    with x = " << x << "\n");
				goto Lgm;
			}
			if(x==GetRadiansToDegreesFactor<Value_t>())
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(101,
					"x[x==GetRadiansToDegreesFactor<Value_t>()] cMul",
					"cDeg",
					"    with x = " << x << "\n");
				goto Lgn;
			}
			if(x==GetDegreesToRadiansFactor<Value_t>())
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(102,
					"x[x==GetDegreesToRadiansFactor<Value_t>()] cMul",
					"cRad",
					"    with x = " << x << "\n");
				goto Lgo;
			}
			if(x==Value_t(-1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(137,
					"x[x==Value_t(-1)] cMul",
					"cNeg",
					"    with x = " << x << "\n");
				goto Lgp;
			}
			break;
		default: Default1:;
			A = ByteCodePtr[0];
			if(A>=VarBegin)
			{
				switch(ByteCodePtr[-1])
				{
				case cMul:
					switch(ByteCodePtr[-2])
					{
					case cNeg:
						B = ByteCodePtr[-3];
						if(B==A)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(348,
								"B[B==A] cNeg cMul A[A>=VarBegin] cMul",
								"B cSqr cMul cNeg",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", B = " << FP_TRACE_OPCODENAME(B)
								    << "\n");
							/* ByteCodePtr[-3] = B; */ // redundant, matches B @ 4
							goto Lff;
						}
						goto Default4;
					default: Default4:;
						B = ByteCodePtr[-2];
						if(B==A)
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(339,
								"B[B==A] cMul A[A>=VarBegin] cMul",
								"B cSqr cMul",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", B = " << FP_TRACE_OPCODENAME(B)
								    << "\n");
							/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
							/* opcode = cMul; */ // redundant, matches cMul @ 0
							goto Lgq;
						}
					}
					goto Default5;
				case cNeg:
					B = ByteCodePtr[-2];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(342,
							"B[B==A] cNeg A[A>=VarBegin] cMul",
							"B cSqr cNeg",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lfg;
					}
					goto Default5;
				default: Default5:;
					B = ByteCodePtr[-1];
					if(B==A)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(336,
							"B[B==A] A[A>=VarBegin] cMul",
							"B cSqr",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-1] = B; */ // redundant, matches B @ 2
						goto Lfd;
					}
				}
			}
			if(IsUnaryOpcode(A))
			{
				B = ByteCodePtr[-1];
				if(B>=VarBegin&&data->ByteCode.size()>1)
				{
					if(ByteCodePtr[-2] == cMul)
					{
						C = ByteCodePtr[-3];
						if(C==A)
						{
							D = ByteCodePtr[-4];
							if(D==B)
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(358,
									"D[D==B] C[C==A] cMul B[B>=VarBegin&&data->ByteCode.size()>1] A[IsUnaryOpcode(A)] cMul",
									"D C cSqr cMul",
									"    with A = " << FP_TRACE_OPCODENAME(A)
									    << ", B = " << FP_TRACE_OPCODENAME(B)
									    << ", C = " << FP_TRACE_OPCODENAME(C)
									    << ", D = " << FP_TRACE_OPCODENAME(D)
									    << "\n");
								/* ByteCodePtr[-4] = D; */ // redundant, matches D @ 5
								/* ByteCodePtr[-3] = C; */ // redundant, matches C @ 4
								/* opcode = cMul; */ // redundant, matches cMul @ 0
								goto Lha;
							}
						}
					}
				}
			}
		}
		goto Default0;
	TailCall_cNEqual:
	case cNEqual:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(217,
						"cAbs x[x==Value_t(0)] cNEqual",
						"[x] cNEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cNEqual; */ // redundant, matches cNEqual @ 0
					goto Lhb;
				case cSqr:
					FP_TRACE_BYTECODE_OPTIMIZATION(219,
						"cSqr x[x==Value_t(0)] cNEqual",
						"[x] cNEqual",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cNEqual; */ // redundant, matches cNEqual @ 0
					goto Lhb;
				}
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(129,
					"y x cNEqual",
					"[fp_nequal(y,x)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lhc;
			}
		}
		goto Default0;
	TailCall_cNeg:
	case cNeg:
		switch(ByteCodePtr[0])
		{
		case cMul:
			if(ByteCodePtr[-1] == cImmed)
			{
				x = ImmedPtr[0];
				FP_TRACE_BYTECODE_OPTIMIZATION(136,
					"x cMul cNeg",
					"[-x] cMul",
					"    with x = " << x << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches x @ 2
				goto Lhd;
			}
			break;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(199,"cNeg cNeg", "", "");
			goto Lbg;
		case cSin:
			if(ByteCodePtr[-1] == cMul)
			{
				if(ByteCodePtr[-2] == cImmed)
				{
					x = ImmedPtr[0];
					FP_TRACE_BYTECODE_OPTIMIZATION(310,
						"x cMul cSin cNeg",
						"[-x] cMul cSin",
						"    with x = " << x << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches x @ 3
					goto Lhe;
				}
			}
			break;
		case cSinh:
			if(ByteCodePtr[-1] == cMul)
			{
				if(ByteCodePtr[-2] == cImmed)
				{
					x = ImmedPtr[0];
					FP_TRACE_BYTECODE_OPTIMIZATION(311,
						"x cMul cSinh cNeg",
						"[-x] cMul cSinh",
						"    with x = " << x << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches x @ 3
					goto Lhf;
				}
			}
			break;
		case cTan:
			if(ByteCodePtr[-1] == cMul)
			{
				if(ByteCodePtr[-2] == cImmed)
				{
					x = ImmedPtr[0];
					FP_TRACE_BYTECODE_OPTIMIZATION(312,
						"x cMul cTan cNeg",
						"[-x] cMul cTan",
						"    with x = " << x << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches x @ 3
					goto Lhg;
				}
			}
			break;
		case cTanh:
			if(ByteCodePtr[-1] == cMul)
			{
				if(ByteCodePtr[-2] == cImmed)
				{
					x = ImmedPtr[0];
					FP_TRACE_BYTECODE_OPTIMIZATION(313,
						"x cMul cTanh cNeg",
						"[-x] cMul cTanh",
						"    with x = " << x << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches x @ 3
					goto Lhh;
				}
			}
			break;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(68,
				"x cNeg",
				"[-x]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lhi;
		}
		goto Default0;
	TailCall_cNot:
	case cNot:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(249,"cAbs cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Lhj;
		case cAbsNot:
			A = ByteCodePtr[-1];
			if(IsLogicalOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(254,
					"A[IsLogicalOpcode(A)] cAbsNot cNot",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lbg;
			}
			if(A!=cImmed)
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(255,
					"A[A!=cImmed] cAbsNot cNot",
					"A cAbsNotNot",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lhk;
			}
			goto Default6;
		case cAbsNotNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(252,"cAbsNotNot cNot", "cAbsNot", "");
			goto Lhl;
		case cEqual:
			FP_TRACE_BYTECODE_OPTIMIZATION(213,"cEqual cNot", "cNEqual", "");
			goto Lhm;
		case cGreater:
			FP_TRACE_BYTECODE_OPTIMIZATION(211,"cGreater cNot", "cLessOrEq", "");
			goto Lhn;
		case cGreaterOrEq:
			FP_TRACE_BYTECODE_OPTIMIZATION(212,"cGreaterOrEq cNot", "cLess", "");
			goto Lho;
		case cLess:
			FP_TRACE_BYTECODE_OPTIMIZATION(209,"cLess cNot", "cGreaterOrEq", "");
			goto Lhp;
		case cLessOrEq:
			FP_TRACE_BYTECODE_OPTIMIZATION(210,"cLessOrEq cNot", "cGreater", "");
			goto Lhq;
		case cNEqual:
			FP_TRACE_BYTECODE_OPTIMIZATION(214,"cNEqual cNot", "cEqual", "");
			goto Lia;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(248,"cNeg cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Lhj;
		case cNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(250,"cNot cNot", "cNotNot", "");
			goto Lib;
		case cNotNot:
			FP_TRACE_BYTECODE_OPTIMIZATION(251,"cNotNot cNot", "cNot", "");
			/* opcode = cNot; */ // redundant, matches cNot @ 0
			goto Lhj;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(85,
				"x cNot",
				"[fp_not(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lic;
		default: Default6:;
			A = ByteCodePtr[0];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(256,
					"A[IsNeverNegativeValueOpcode(A)] cNot",
					"A cAbsNot",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				goto Lid;
			}
		}
		goto Default0;
	TailCall_cOr:
	case cOr:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(131,
					"y x cOr",
					"[fp_or(x,y)]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Lie;
			}
		}
		goto Default0;
	TailCall_cPow:
	case cPow:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			if(!isEvenInteger(x+x))
			{
				if(ByteCodePtr[-1] == cSqr)
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(14,
						"cSqr x[!isEvenInteger(x+x)] cPow",
						"cAbs [x+x] cPow",
						"    with x = " << x << "\n");
					/* opcode = cPow; */ // redundant, matches cPow @ 0
					goto Lif;
				}
			}
			if(IsIntegerConst(x))
			{
				switch(ByteCodePtr[-1])
				{
				case cExp:
					FP_TRACE_BYTECODE_OPTIMIZATION(35,
						"cExp x[IsIntegerConst(x)] cPow",
						"[x] cMul cExp",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					goto Lig;
				case cExp2:
					FP_TRACE_BYTECODE_OPTIMIZATION(36,
						"cExp2 x[IsIntegerConst(x)] cPow",
						"[x] cMul cExp2",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					goto Lih;
				case cPow:
					if(ByteCodePtr[-2] == cImmed)
					{
						y = ImmedPtr[-1];
						if(!IsIntegerConst(y))
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(34,
								"y[!IsIntegerConst(y)] cPow x[IsIntegerConst(x)] cPow",
								"[y*x] cPow",
								"    with x = " << x
								    << ", y = " << y
								    << "\n");
							/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
							/* opcode = cPow; */ // redundant, matches cPow @ 0
							goto Lii;
						}
					}
					FP_TRACE_BYTECODE_OPTIMIZATION(37,
						"cPow x[IsIntegerConst(x)] cPow",
						"[x] cMul cPow",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cPow; */ // redundant, matches cPow @ 0
					goto Lij;
				}
			}
			if(isEvenInteger(x))
			{
				switch(ByteCodePtr[-1])
				{
				case cAbs:
					FP_TRACE_BYTECODE_OPTIMIZATION(299,
						"cAbs x[isEvenInteger(x)] cPow",
						"[x] cPow",
						"    with x = " << x << "\n");
					/* ImmedPtr[0] = x; */ // redundant, matches x @ 1
					/* opcode = cPow; */ // redundant, matches cPow @ 0
					goto Lik;
				case cMul:
					if(ByteCodePtr[-2] == cAbs)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(300,
							"cAbs cMul x[isEvenInteger(x)] cPow",
							"cMul [x] cPow",
							"    with x = " << x << "\n");
						/* opcode = cPow; */ // redundant, matches cPow @ 0
						goto Lil;
					}
					break;
				}
			}
			if(x==Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(122,
					"x[x==Value_t(0)] cPow",
					"[Value_t(0)] cMul [Value_t(1)] cAdd",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Lim;
			}
			if(x==Value_t(0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(175,
					"x[x==Value_t(0.5)] cPow",
					"cSqrt",
					"    with x = " << x << "\n");
				goto Lin;
			}
			if(x==Value_t(1)/Value_t(3))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(176,
					"x[x==Value_t(1)/Value_t(3)] cPow",
					"cCbrt",
					"    with x = " << x << "\n");
				goto Lio;
			}
			if(x==Value_t(1)/Value_t(-3))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(177,
					"x[x==Value_t(1)/Value_t(-3)] cPow",
					"cCbrt cInv",
					"    with x = " << x << "\n");
				goto Lip;
			}
			if(x==Value_t(-0.5))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(178,
					"x[x==Value_t(-0.5)] cPow",
					"cRSqrt",
					"    with x = " << x << "\n");
				goto Liq;
			}
			if(x==Value_t(-1))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(179,
					"x[x==Value_t(-1)] cPow",
					"cInv",
					"    with x = " << x << "\n");
				goto Lja;
			}
			switch(ByteCodePtr[-1])
			{
			case cPow:
				if(ByteCodePtr[-2] == cImmed)
				{
					y = ImmedPtr[-1];
					if(isEvenInteger(y)&&!isEvenInteger(x*y))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(13,
							"y[isEvenInteger(y)&&!isEvenInteger(x*y)] cPow x cPow",
							"cAbs [y*x] cPow",
							"    with x = " << x
							    << ", y = " << y
							    << "\n");
						/* opcode = cPow; */ // redundant, matches cPow @ 0
						goto Ljb;
					}
					FP_TRACE_BYTECODE_OPTIMIZATION(173,
						"y cPow x cPow",
						"[y*x] cPow",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
					/* opcode = cPow; */ // redundant, matches cPow @ 0
					goto Lii;
				}
				break;
			case cSqr:
				FP_TRACE_BYTECODE_OPTIMIZATION(38,
					"cSqr x cPow",
					"[x+x] cPow",
					"    with x = " << x << "\n");
				/* opcode = cPow; */ // redundant, matches cPow @ 0
				goto Ljc;
			case cImmed:
				y = ImmedPtr[-1];
				if(y!=Value_t(0)||x>=Value_t(0))
				{
					FP_TRACE_BYTECODE_OPTIMIZATION(84,
						"y[y!=Value_t(0)||x>=Value_t(0)] x cPow",
						"[fp_pow(y,x)]",
						"    with x = " << x
						    << ", y = " << y
						    << "\n");
					/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
					goto Ljd;
				}
				break;
			}
			FP_TRACE_BYTECODE_OPTIMIZATION(333,
				"x cPow",
				"[DO_POWI]",
				"    with x = " << x << "\n");
			if(TryCompilePowi(x))
			  return;
		}
		goto Default0;
	TailCall_cRad:
	case cRad:
		if(ByteCodePtr[0] == cImmed)
		{
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(66,
				"x cRad",
				"[DegreesToRadians(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lje;
		}
		goto Default0;
	TailCall_cSin:
	case cSin:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(306,"cNeg cSin", "cSin cNeg", "");
			goto Ljf;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(58,
				"x cSin",
				"[fp_sin(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ljg;
		}
		goto Default0;
	TailCall_cSinh:
	case cSinh:
		switch(ByteCodePtr[0])
		{
		case cAcosh:
			FP_TRACE_BYTECODE_OPTIMIZATION(315,"cAcosh cSinh", "[DO_STACKPLUS1] cSqr [Value_t(-1)] cAdd cSqrt", "");
			incStackPtr();
			--StackPtr;
			goto Ljh;
		case cAsinh:
			FP_TRACE_BYTECODE_OPTIMIZATION(192,"cAsinh cSinh", "", "");
			goto Lbg;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(307,"cNeg cSinh", "cSinh cNeg", "");
			goto Lji;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(59,
				"x cSinh",
				"[fp_sinh(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ljj;
		}
		goto Default0;
	TailCall_cSqr:
	case cSqr:
		switch(ByteCodePtr[0])
		{
		case cAbs:
			FP_TRACE_BYTECODE_OPTIMIZATION(354,"cAbs cSqr", "cSqr", "");
			/* opcode = cSqr; */ // redundant, matches cSqr @ 0
			goto Ljk;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(353,"cNeg cSqr", "cSqr", "");
			/* opcode = cSqr; */ // redundant, matches cSqr @ 0
			goto Ljk;
		case cSqrt:
			A = ByteCodePtr[-1];
			if(IsNeverNegativeValueOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(181,
					"A[IsNeverNegativeValueOpcode(A)] cSqrt cSqr",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[-1] = A; */ // redundant, matches A @ 2
				goto Lbg;
			}
			break;
		}
		goto Default0;
	TailCall_cSqrt:
	case cSqrt:
		switch(ByteCodePtr[0])
		{
		case cSqr:
			FP_TRACE_BYTECODE_OPTIMIZATION(15,"cSqr cSqrt", "cAbs", "");
			goto Ljl;
		case cImmed:
			x = ImmedPtr[0];
			if(x>=Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(60,
					"x[x>=Value_t(0)] cSqrt",
					"[fp_sqrt(x)]",
					"    with x = " << x << "\n");
				/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
				goto Ljm;
			}
			break;
		}
		goto Default0;
	TailCall_cSub:
	case cSub:
		switch(ByteCodePtr[0])
		{
		case cDup:
			FP_TRACE_BYTECODE_OPTIMIZATION(152,"cDup cSub", "[Value_t(0)] cMul", "");
			goto Ljn;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(205,"cNeg cSub", "cAdd", "");
			goto Ljo;
		case cImmed:
			x = ImmedPtr[0];
			if(x==Value_t(0))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(77,
					"x[x==Value_t(0)] cSub",
					"",
					"    with x = " << x << "\n");
				goto Lak;
			}
			if(ByteCodePtr[-1] == cImmed)
			{
				y = ImmedPtr[-1];
				FP_TRACE_BYTECODE_OPTIMIZATION(78,
					"y x cSub",
					"[y-x]",
					"    with x = " << x
					    << ", y = " << y
					    << "\n");
				/* ByteCodePtr[-1] = cImmed; */ // redundant, matches y @ 2
				goto Ljp;
			}
			FP_TRACE_BYTECODE_OPTIMIZATION(168,
				"x cSub",
				"[-x] cAdd",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Ljq;
		}
		goto Default0;
	TailCall_cTan:
	case cTan:
		switch(ByteCodePtr[0])
		{
		case cAtan2:
			FP_TRACE_BYTECODE_OPTIMIZATION(196,"cAtan2 cTan", "cDiv", "");
			goto Lfe;
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(308,"cNeg cTan", "cTan cNeg", "");
			goto Lka;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(62,
				"x cTan",
				"[fp_tan(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lkb;
		}
		goto Default0;
	TailCall_cTanh:
	case cTanh:
		switch(ByteCodePtr[0])
		{
		case cNeg:
			FP_TRACE_BYTECODE_OPTIMIZATION(309,"cNeg cTanh", "cTanh cNeg", "");
			goto Lkc;
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(63,
				"x cTanh",
				"[fp_tanh(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lkd;
		}
		goto Default0;
	TailCall_cTrunc:
	case cTrunc:
		switch(ByteCodePtr[0])
		{
		case cImmed:
			x = ImmedPtr[0];
			FP_TRACE_BYTECODE_OPTIMIZATION(64,
				"x cTrunc",
				"[fp_trunc(x)]",
				"    with x = " << x << "\n");
			/* ByteCodePtr[0] = cImmed; */ // redundant, matches x @ 1
			goto Lke;
		default:
			A = ByteCodePtr[0];
			if(IsAlwaysIntegerOpcode(A))
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(259,
					"A[IsAlwaysIntegerOpcode(A)] cTrunc",
					"A",
					"    with A = " << FP_TRACE_OPCODENAME(A) << "\n");
				/* ByteCodePtr[0] = A; */ // redundant, matches A @ 1
				return;
			}
		}
		goto Default0;
	default: Default0:;
		A = opcode;
		if(IsComparisonOpcode(A))
		{
			if(ByteCodePtr[0] == cImmed)
			{
				x = ImmedPtr[0];
				switch(ByteCodePtr[-1])
				{
				case cAdd:
					if(ByteCodePtr[-2] == cImmed)
					{
						y = ImmedPtr[-1];
						FP_TRACE_BYTECODE_OPTIMIZATION(221,
							"y cAdd x A[IsComparisonOpcode(A)]",
							"[x-y] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << ", y = " << y
							    << "\n");
						/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
						goto Lkf;
					}
					break;
				case cAtan:
					if(fp_abs(x)<fp_const_pi<Value_t>()*Value_t(0.5))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(237,
							"cAtan[fp_abs(x)<fp_const_pi<Value_t>()*Value_t(0.5)] x A[IsComparisonOpcode(A)]",
							"[fp_tan(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						goto Lkg;
					}
					break;
				case cExp:
					if(x>Value_t(0))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(227,
							"cExp[x>Value_t(0)] x A[IsComparisonOpcode(A)]",
							"[fp_log(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						goto Lkh;
					}
					break;
				case cExp2:
					if(x>Value_t(0))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(228,
							"cExp2[x>Value_t(0)] x A[IsComparisonOpcode(A)]",
							"[fp_log2(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						goto Lki;
					}
					break;
				case cLog:
					B = ByteCodePtr[-2];
					if(IsNeverNegativeValueOpcode(B))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(230,
							"B[IsNeverNegativeValueOpcode(B)] cLog x A[IsComparisonOpcode(A)]",
							"B [fp_exp(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lkj;
					}
					break;
				case cLog10:
					B = ByteCodePtr[-2];
					if(IsNeverNegativeValueOpcode(B))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(232,
							"B[IsNeverNegativeValueOpcode(B)] cLog10 x A[IsComparisonOpcode(A)]",
							"B [fp_pow(Value_t(10),x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lkk;
					}
					break;
				case cLog2:
					B = ByteCodePtr[-2];
					if(IsNeverNegativeValueOpcode(B))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(231,
							"B[IsNeverNegativeValueOpcode(B)] cLog2 x A[IsComparisonOpcode(A)]",
							"B [fp_exp2(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << "\n");
						/* ByteCodePtr[-2] = B; */ // redundant, matches B @ 3
						goto Lkl;
					}
					break;
				case cMul:
					if(ByteCodePtr[-2] == cImmed)
					{
						y = ImmedPtr[-1];
						if(y>Value_t(0))
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(223,
								"y[y>Value_t(0)] cMul x A[IsComparisonOpcode(A)]",
								"[x/y] A",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", x = " << x
								    << ", y = " << y
								    << "\n");
							/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
							goto Lkm;
						}
						if(y<Value_t(0))
						{
							FP_TRACE_BYTECODE_OPTIMIZATION(224,
								"y[y<Value_t(0)] cMul x A[IsComparisonOpcode(A)]",
								"[x/y] {OppositeComparisonOpcode(A)}",
								"    with A = " << FP_TRACE_OPCODENAME(A)
								    << ", x = " << x
								    << ", y = " << y
								    << "\n");
							/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
							goto Lkn;
						}
					}
					break;
				case cNeg:
					FP_TRACE_BYTECODE_OPTIMIZATION(222,
						"cNeg x A[IsComparisonOpcode(A)]",
						"[-x] {OppositeComparisonOpcode(A)}",
						"    with A = " << FP_TRACE_OPCODENAME(A)
						    << ", x = " << x
						    << "\n");
					goto Lko;
				case cPow:
					if(x>Value_t(0))
					{
						if(ByteCodePtr[-2] == cImmed)
						{
							y = ImmedPtr[-1];
							if(y>Value_t(0))
							{
								FP_TRACE_BYTECODE_OPTIMIZATION(225,
									"y[y>Value_t(0)] cPow[x>Value_t(0)] x A[IsComparisonOpcode(A)]",
									"[fp_pow(x,1/y)] A",
									"    with A = " << FP_TRACE_OPCODENAME(A)
									    << ", x = " << x
									    << ", y = " << y
									    << "\n");
								/* ByteCodePtr[-2] = cImmed; */ // redundant, matches y @ 3
								goto Lkp;
							}
						}
					}
					break;
				case cSinh:
					FP_TRACE_BYTECODE_OPTIMIZATION(238,
						"cSinh x A[IsComparisonOpcode(A)]",
						"[fp_asinh(x)] A",
						"    with A = " << FP_TRACE_OPCODENAME(A)
						    << ", x = " << x
						    << "\n");
					goto Lkq;
				case cSqr:
					if(x>Value_t(0))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(226,
							"cSqr[x>Value_t(0)] x A[IsComparisonOpcode(A)]",
							"cAbs [fp_sqrt(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						goto Lla;
					}
					break;
				case cTanh:
					if(fp_abs(x)<Value_t(1))
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(239,
							"cTanh[fp_abs(x)<Value_t(1)] x A[IsComparisonOpcode(A)]",
							"[fp_atanh(x)] A",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", x = " << x
							    << "\n");
						goto Llb;
					}
					break;
				}
			}
		}
		if(A>=VarBegin&&data->ByteCode.size()>0)
		{
			B = ByteCodePtr[0];
			if(B==A)
			{
				FP_TRACE_BYTECODE_OPTIMIZATION(356,
					"B[B==A] A[A>=VarBegin&&data->ByteCode.size()>0]",
					"B cDup",
					"    with A = " << FP_TRACE_OPCODENAME(A)
					    << ", B = " << FP_TRACE_OPCODENAME(B)
					    << "\n");
				/* ByteCodePtr[0] = B; */ // redundant, matches B @ 1
				goto Llc;
			}
		}
		if(IsUnaryOpcode(A))
		{
			B = ByteCodePtr[0];
			if(B>=VarBegin&&data->ByteCode.size()>1)
			{
				C = ByteCodePtr[-1];
				if(C==A)
				{
					D = ByteCodePtr[-2];
					if(D==B)
					{
						FP_TRACE_BYTECODE_OPTIMIZATION(357,
							"D[D==B] C[C==A] B[B>=VarBegin&&data->ByteCode.size()>1] A[IsUnaryOpcode(A)]",
							"D C cDup",
							"    with A = " << FP_TRACE_OPCODENAME(A)
							    << ", B = " << FP_TRACE_OPCODENAME(B)
							    << ", C = " << FP_TRACE_OPCODENAME(C)
							    << ", D = " << FP_TRACE_OPCODENAME(D)
							    << "\n");
						/* ByteCodePtr[-2] = D; */ // redundant, matches D @ 3
						/* ByteCodePtr[-1] = C; */ // redundant, matches C @ 2
						goto Lld;
					}
				}
			}
		}
	}
	goto Lle;
Laa: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Llf: goto TailCall_cAbs;
Lab: ImmedPtr[0] = fp_abs(x); return;
Lac: ImmedPtr[0] = fp_acos(x); return;
Lad: ImmedPtr[0] = fp_acosh(x); return;
Lae: data->Immed.push_back(Value_t(4));
     ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
Llg: for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Llh: opcode = cMul;
Lli: FP_ReDefinePointers();
Llj: goto TailCall_cMul;
Laf: for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     data->Immed.push_back(Value_t(4));
Llk: data->ByteCode.push_back(cImmed); goto Llh;
Lag: ImmedPtr[0] = x+Value_t(1);
     ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lll: opcode = cMul; goto Llj;
Lah: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cSub;
Llm: goto TailCall_cSub;
Lai: ImmedPtr[-1] = y+x;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lln: FP_ReDefinePointers();
Llo: goto TailCall_cAdd;
Laj: ImmedPtr[-1] = y+x;
Lak: data->Immed.pop_back();
Lbg: data->ByteCode.pop_back(); return;
Lal: ImmedPtr[-1] = fp_and(x,y); goto Lak;
Lam: ImmedPtr[0] = fp_asin(x); return;
Lan: ImmedPtr[0] = fp_asinh(x); return;
Lao: ImmedPtr[0] = fp_atan(x); return;
Lap: ImmedPtr[-1] = fp_atan2(y,x); goto Lak;
Laq: ImmedPtr[0] = fp_atanh(x); return;
Lba: ImmedPtr[0] = fp_cbrt(x); return;
Lbb: data->ByteCode.pop_back();
     AddFunctionOpcode(cFloor);
Llp: opcode = cNeg;
     FP_ReDefinePointers();
     goto TailCall_cNeg;
Lbc: ImmedPtr[0] = fp_ceil(x); return;
Lbd: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Llq: goto TailCall_cCos;
Lbe: ImmedPtr[0] = fp_cos(x); return;
Lbf: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     goto TailCall_cCosh;
Lbh: data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr);
     data->Immed.push_back(Value_t(1));
Lma: data->ByteCode.push_back(cImmed);
     AddFunctionOpcode(cAdd);
Lmb: opcode = cSqrt;
     FP_ReDefinePointers();
     goto TailCall_cSqrt;
Lbi: ImmedPtr[0] = fp_cosh(x); return;
Lbj: ImmedPtr[0] = RadiansToDegrees(x); return;
Lbk: data->ByteCode.pop_back();
     AddFunctionOpcode(cSec); goto Llh;
Lbl: data->ByteCode.pop_back();
     AddFunctionOpcode(cTan); goto Llh;
Lbm: data->ByteCode.pop_back();
     AddFunctionOpcode(cSin); goto Llh;
Lbn: data->Immed.push_back(Value_t(0));
     ByteCodePtr[0] = cImmed;
Lmc: AddFunctionOpcode(cMul);
     data->Immed.push_back(Value_t(1));
Lmd: data->ByteCode.push_back(cImmed);
Lme: opcode = cAdd; goto Lln;
Lbo: data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg);
     AddFunctionOpcode(cExp); goto Llh;
Lbp: data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg);
     AddFunctionOpcode(cExp2); goto Llh;
Lbq: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lll;
Lca: data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg);
     AddFunctionOpcode(cPow); goto Llh;
Lcb: data->ByteCode.pop_back();
     AddFunctionOpcode(cCos); goto Llh;
Lcc: data->ByteCode.pop_back();
     AddFunctionOpcode(cCsc); goto Llh;
Lcd: data->ByteCode.pop_back();
     AddFunctionOpcode(cCot); goto Llh;
Lce: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
Lmf: opcode = cDeg;
     FP_ReDefinePointers();
     goto TailCall_cDeg;
Lcf: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
Lmg: opcode = cRad;
     FP_ReDefinePointers();
     goto TailCall_cRad;
Lcg: ImmedPtr[-1] = y/x;
     data->Immed.pop_back(); goto Llg;
Lch: ImmedPtr[0] = -x;
     ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lmh: goto TailCall_cDiv;
Lci: ImmedPtr[-1] = y/x; goto Lak;
Lcj: ImmedPtr[0] = Value_t(1)/x; goto Lll;
Lck: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lmi: goto TailCall_cEqual;
Lcl: ImmedPtr[-1] = fp_equal(y,x); goto Lak;
Lcm: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cExp);
     data->Immed.push_back(fp_exp(x)); goto Llk;
Lcn: ImmedPtr[0] = fp_exp(x); return;
Lco: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cExp2);
     data->Immed.push_back(fp_exp2(x)); goto Llk;
Lcp: ImmedPtr[0] = fp_exp2(x); return;
Lcq: data->Immed.push_back(fp_log(Value_t(2)));
     data->ByteCode.push_back(cImmed);
Lmj: AddFunctionOpcode(cMul);
     opcode = cExp;
     FP_ReDefinePointers();
     goto TailCall_cExp;
Lda: data->ByteCode.pop_back();
     AddFunctionOpcode(cCeil); goto Llp;
Ldb: ImmedPtr[0] = fp_floor(x); return;
Ldc: ImmedPtr[-1] = fp_less(x,y); goto Lak;
Ldd: data->Immed.pop_back();
     data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg);
Lid: AddFunctionOpcode(cAbsNot); return;
Lde: ImmedPtr[0] = Value_t(0.5)/x;
     ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
Lmk: AddFunctionOpcode(cNotNot); return;
Ldf: ImmedPtr[-1] = fp_lessOrEq(x,y); goto Lak;
Ldg: data->Immed.pop_back();
Lhk: data->ByteCode.pop_back();
Lml: AddFunctionOpcode(cAbsNotNot); return;
Ldh: ImmedPtr[0] = fp_int(x); return;
Ldi: data->ByteCode.pop_back();
     AddFunctionOpcode(cSec); return;
Ldj: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cTan;
Lmm: goto TailCall_cTan;
Ldk: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cSin;
Lmn: goto TailCall_cSin;
Ldl: data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg);
     opcode = cPow;
Lmo: FP_ReDefinePointers();
Lmp: goto TailCall_cPow;
Ldm: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cCos; goto Llq;
Ldn: data->ByteCode.pop_back();
     AddFunctionOpcode(cCsc); return;
Ldo: data->ByteCode.pop_back();
     AddFunctionOpcode(cRSqrt); return;
Ldp: data->ByteCode.pop_back();
     AddFunctionOpcode(cCot); return;
Ldq: ImmedPtr[0] = Value_t(1)/x; return;
Lea: ImmedPtr[0] = Value_t(0.5)/x;
     ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cNot;
     FP_ReDefinePointers();
Lmq: goto TailCall_cNot;
Leb: ImmedPtr[-1] = fp_less(y,x); goto Lak;
Lec: data->Immed.pop_back();
Lhl: data->ByteCode.pop_back(); goto Lid;
Led: ImmedPtr[-1] = fp_lessOrEq(y,x); goto Lak;
Lee: data->Immed.pop_back();
     data->ByteCode.pop_back();
     AddFunctionOpcode(cNeg); goto Lml;
Lef: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cLog);
     data->Immed.push_back(fp_log(x)); goto Lmd;
Leg: data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     AddFunctionOpcode(cLog);
Lna: data->ByteCode.push_back(cDup); goto Lme;
Leh: ImmedPtr[0] = fp_log(x); return;
Lei: data->Immed.push_back(fp_log10(fp_const_e<Value_t>()));
Lnb: ByteCodePtr[0] = cImmed; goto Llh;
Lej: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cLog10);
     data->Immed.push_back(fp_log10(x)); goto Lmd;
Lek: data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     AddFunctionOpcode(cLog10); goto Lna;
Lel: ImmedPtr[0] = fp_log10(x); return;
Lem: data->Immed.push_back(fp_log2(fp_const_e<Value_t>())); goto Lnb;
Len: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cLog2);
     data->Immed.push_back(fp_log2(x)); goto Lmd;
Leo: data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     AddFunctionOpcode(cLog2); goto Lna;
Lep: ImmedPtr[0] = fp_log2(x); return;
Leq: ImmedPtr[-1] = fp_max(x,y); goto Lak;
Lfa: ImmedPtr[-1] = fp_min(x,y); goto Lak;
Lfb: ImmedPtr[-1] = fp_mod(y,x); goto Lak;
Lfc: ImmedPtr[-1] = x;
     data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(A);
Lnc: AddFunctionOpcode(cMul);
     data->Immed.push_back(y*x); goto Lmd;
Lfd: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cSqr;
Lnd: goto TailCall_cSqr;
Lfe: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cDiv; goto Lmh;
Lff: for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr);
     AddFunctionOpcode(cMul); goto Llp;
Lfg: for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr); goto Llp;
Lfh: ImmedPtr[0] = x+Value_t(1);
     ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     opcode = cPow; goto Lmp;
Lfi: ByteCodePtr[-2] = cImmed;
     ByteCodePtr -= 2;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Llj;
Lfj: ImmedPtr[-1] = x;
Lne: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lli;
Lfk: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
Lnf: for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
Lng: AddFunctionOpcode(A);
     data->Immed.push_back(x);
Lnh: data->ByteCode.push_back(cImmed); goto Lli;
Lfl: data->Immed.pop_back(); goto Lnf;
Lfm: data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(B); goto Lng;
Lfn: data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); goto Lng;
Lfo: ByteCodePtr[-1] = cImmed; goto Lbg;
Lfp: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Llj;
Lfq: data->Immed.pop_back();
Lni: for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); return;
Lga: ImmedPtr[0] = x+x; goto Lfi;
Lgb: ImmedPtr[-1] = x;
     ByteCodePtr[-4] = cImmed;
     data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     AddFunctionOpcode(A);
     data->Immed.push_back(y*x);
     data->ByteCode.push_back(cImmed);
     AddFunctionOpcode(cMul); goto Lme;
Lgc: ImmedPtr[-1] = x;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lnc;
Lgd: ImmedPtr[0] = RadiansToDegrees(x); goto Lfp;
Lge: data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back(); goto Lli;
Lgf: data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     data->Immed.push_back(x+x); goto Lnh;
Lgg: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back(); goto Lni;
Lgh: ImmedPtr[-1] = y*x; goto Lne;
Lgi: ImmedPtr[0] = -x; goto Lfp;
Lgj: ImmedPtr[0] = DegreesToRadians(x); goto Lfp;
Lgk: ImmedPtr[-1] = x;
     ByteCodePtr[-4] = cImmed;
     data->Immed.pop_back();
     for(unsigned tmp=4; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     AddFunctionOpcode(A);
     data->Immed.push_back(y*x);
     data->ByteCode.push_back(cImmed);
     AddFunctionOpcode(cMul);
     opcode = cSub;
     FP_ReDefinePointers(); goto Llm;
Lgl: ImmedPtr[-1] = y*x; goto Lak;
Lgm: ByteCodePtr[0] = cDup;
     ImmedPtr -= 1;
     data->Immed.pop_back();
Lnj: opcode = cAdd; goto Llo;
Lgn: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lmf;
Lgo: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lmg;
Lgp: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Llp;
Lgq: for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lnk: AddFunctionOpcode(cSqr); goto Lli;
Lha: for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back(); goto Lnk;
Lhb: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back();
Lnl: goto TailCall_cNEqual;
Lhc: ImmedPtr[-1] = fp_nequal(y,x); goto Lak;
Lhd: ImmedPtr[0] = -x; goto Lbq;
Lhe: ImmedPtr[0] = -x;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cSin;
     FP_ReDefinePointers(); goto Lmn;
Lhf: ImmedPtr[0] = -x;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cSinh;
     FP_ReDefinePointers();
     goto TailCall_cSinh;
Lhg: ImmedPtr[0] = -x;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cTan;
     FP_ReDefinePointers(); goto Lmm;
Lhh: ImmedPtr[0] = -x;
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cTanh;
     FP_ReDefinePointers();
     goto TailCall_cTanh;
Lhi: ImmedPtr[0] = -x; return;
Lhj: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lmq;
Lhm: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cNEqual; goto Lnl;
Lhn: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cLessOrEq;
     goto TailCall_cLessOrEq;
Lho: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cLess;
     goto TailCall_cLess;
Lhp: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cGreaterOrEq;
     goto TailCall_cGreaterOrEq;
Lhq: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cGreater;
     goto TailCall_cGreater;
Lia: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cEqual; goto Lmi;
Lib: data->ByteCode.pop_back(); goto Lmk;
Lic: ImmedPtr[0] = fp_not(x); return;
Lie: ImmedPtr[-1] = fp_or(x,y); goto Lak;
Lif: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     data->Immed.push_back(x+x);
Lnm: data->ByteCode.push_back(cImmed); goto Lmo;
Lig: ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back(); goto Lmj;
Lih: ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     opcode = cExp2;
     FP_ReDefinePointers();
     goto TailCall_cExp2;
Lii: ImmedPtr[-1] = y*x;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back(); goto Lmo;
Lij: ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back();
     AddFunctionOpcode(cMul); goto Lmo;
Lik: ByteCodePtr[-1] = cImmed;
     ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lmp;
Lil: data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cMul);
     data->Immed.push_back(x); goto Lnm;
Lim: ImmedPtr[0] = Value_t(0); goto Lmc;
Lin: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lmb;
Lio: data->Immed.pop_back();
     data->ByteCode.pop_back();
     opcode = cCbrt;
     FP_ReDefinePointers();
     goto TailCall_cCbrt;
Lip: data->Immed.pop_back();
     data->ByteCode.pop_back();
     AddFunctionOpcode(cCbrt);
Lnn: opcode = cInv;
     FP_ReDefinePointers();
     goto TailCall_cInv;
Liq: data->Immed.pop_back(); goto Ldo;
Lja: data->Immed.pop_back();
     data->ByteCode.pop_back(); goto Lnn;
Ljb: for(unsigned tmp=2; tmp-->0; ) data->Immed.pop_back();
     for(unsigned tmp=3; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     data->Immed.push_back(y*x); goto Lnm;
Ljc: ImmedPtr[0] = x+x; goto Lik;
Ljd: ImmedPtr[-1] = fp_pow(y,x); goto Lak;
Lje: ImmedPtr[0] = DegreesToRadians(x); return;
Ljf: data->ByteCode.pop_back();
     AddFunctionOpcode(cSin); goto Llp;
Ljg: ImmedPtr[0] = fp_sin(x); return;
Ljh: data->ByteCode.pop_back();
     AddFunctionOpcode(cSqr);
     data->Immed.push_back(Value_t(-1)); goto Lma;
Lji: data->ByteCode.pop_back();
     AddFunctionOpcode(cSinh); goto Llp;
Ljj: ImmedPtr[0] = fp_sinh(x); return;
Ljk: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lnd;
Ljl: ByteCodePtr -= 1;
     data->ByteCode.pop_back();
     opcode = cAbs; goto Llf;
Ljm: ImmedPtr[0] = fp_sqrt(x); return;
Ljn: data->Immed.push_back(Value_t(0)); goto Lnb;
Ljo: ByteCodePtr -= 1;
     data->ByteCode.pop_back(); goto Lnj;
Ljp: ImmedPtr[-1] = y-x; goto Lak;
Ljq: ImmedPtr[0] = -x; goto Lnj;
Lka: data->ByteCode.pop_back();
     AddFunctionOpcode(cTan); goto Llp;
Lkb: ImmedPtr[0] = fp_tan(x); return;
Lkc: data->ByteCode.pop_back();
     AddFunctionOpcode(cTanh); goto Llp;
Lkd: ImmedPtr[0] = fp_tanh(x); return;
Lke: ImmedPtr[0] = fp_trunc(x); return;
Lkf: ImmedPtr[-1] = x-y;
Lno: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Lnp: AddFunctionOpcode(A); return;
Lkg: ImmedPtr[0] = fp_tan(x);
Lnq: ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back(); goto Lnp;
Lkh: ImmedPtr[0] = fp_log(x); goto Lnq;
Lki: ImmedPtr[0] = fp_log2(x); goto Lnq;
Lkj: ImmedPtr[0] = fp_exp(x); goto Lnq;
Lkk: ImmedPtr[0] = fp_pow(Value_t(10),x); goto Lnq;
Lkl: ImmedPtr[0] = fp_exp2(x); goto Lnq;
Lkm: ImmedPtr[-1] = x/y; goto Lno;
Lkn: ImmedPtr[-1] = x/y;
     data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
Loa: AddFunctionOpcode(OppositeComparisonOpcode(A)); return;
Lko: ImmedPtr[0] = -x;
     ByteCodePtr[-1] = cImmed;
     data->ByteCode.pop_back(); goto Loa;
Lkp: ImmedPtr[-1] = fp_pow(x,1/y); goto Lno;
Lkq: ImmedPtr[0] = fp_asinh(x); goto Lnq;
Lla: data->Immed.pop_back();
     for(unsigned tmp=2; tmp-->0; ) data->ByteCode.pop_back();
     AddFunctionOpcode(cAbs);
     data->Immed.push_back(fp_sqrt(x));
     data->ByteCode.push_back(cImmed); goto Lnp;
Llb: ImmedPtr[0] = fp_atanh(x); goto Lnq;
Llc: data->ByteCode.push_back(cDup); return;
Lld: ByteCodePtr[0] = cDup; return;
Lle: data->ByteCode.push_back(opcode); return;
return;
// This list of dummy gotos is here to inhibit
// compiler warnings on unused labels
goto TailCall_cAcos;goto TailCall_cAcosh;goto TailCall_cAnd;
goto TailCall_cAsin;goto TailCall_cAsinh;goto TailCall_cAtan;
goto TailCall_cAtan2;goto TailCall_cAtanh;goto TailCall_cCeil;
goto TailCall_cFloor;goto TailCall_cInt;goto TailCall_cLog;
goto TailCall_cLog10;goto TailCall_cLog2;goto TailCall_cMax;
goto TailCall_cMin;goto TailCall_cMod;goto TailCall_cOr;
goto TailCall_cRad;goto TailCall_cSin;goto TailCall_cSinh;
goto TailCall_cSqrt;goto TailCall_cSub;goto TailCall_cTan;
goto TailCall_cTanh;goto TailCall_cTrunc;
#endif

#undef FP_ReDefinePointers
#undef FP_TRACE_BYTECODE_OPTIMIZATION
#undef FP_TRACE_OPCODENAME
